﻿--[[
Name: Babble-Spell-2.2
Revision: $Rev: 15059 $
Author(s): ckknight (ckknight@gmail.com)
Website: http://ckknight.wowinterface.com/
Documentation: http://wiki.wowace.com/index.php/Babble-Spell-2.2
SVN: http://svn.wowace.com/root/trunk/Babble-2.2/Babble-Spell-2.2
Description: A library to provide localizations for spells.
Dependencies: AceLibrary, AceLocale-2.2

Rewritten a little and added some "bosses" by Shino
]]

local spellIcons = {
	-- Adding missing ones
	["Food"] = "",
	["Dense Sharpening Stone"] = "",
	["Greater Fire Protection Potion"] = "",
	["Enriched Manna Biscuit"] = "",
	["Massive Eruption"] = "",
	["Heavy Sharpening Stone"] = "",
	["Starfire Stun"] = "",
	["Weaponsmith"] = "",
	["Soul Siphon"] = "",
	["Solid Sharpening Stone"] = "",
	["Greater Holy Protection Potion"] = "",
	["Shield Bash - Silenced"] = "",
	["Sheep"] = "",
	["Whiteslash"] = "",
	["Enamored Water Spirit"] = "",
	["Rough Sharpening Stone"] = "",
	["Berserker Charge"] = "",
	["Remorseless"] = "",
	["Reckless Charge"] = "",
	["Elemental Leatherworking"] = "",
	["Deep Wounds"] = "",
	["Powerful Anti-Venom"] = "",
	["Greater Arcane Protection Potion"] = "",
	["Greater Nature Protection Potion"] = "",
	["Greater Shadow Protection Potion"] = "",
	["Tribal Leatherworking"] = "",
	["Consecrated Sharpening Stone"] = "",
	["Drink"] = "",
	["Mana"] = "",
	["Explosion"] = "",
	["Herb Gathering"] = "",
	["Kick - Silenced"] = "",
	["Elemental Sharpening Stone"] = "",
	["Greater Frost Protection Potion"] = "",
	["Armorsmith"] = "",
	["Icy Chill"] = "",
	["Dragonscale Leatherworking"] = "",
	["Counterspell - Silenced"] = "",
	["Lockpicking"] = "",
	["Energy"] = "",
	["Coarse Sharpening Stone"] = "",

	-- Costum Icons
	["Purification Potion"] = "inv_potion_01",
	["Restorative Potion"] = "inv_potion_01",
	["Negative Charge"] = "spell_chargenegative",
	["Positive Charge"] = "spell_chargepositive",
	["Void Zone"] = "spell_frost_icestorm",
	["Plague Cloud"] = "ability_creature_disease_02",
	["Mana Detonation"] = "spell_nature_wispsplode",
	["Shadow Fissure"] = "spell_shadow_creepingplague",
	["Tidal Charm"] = "spell_frost_summonwaterelemental",
	["Toxin Cloud"] = "spell_nature_abolishmagic",
	["Unholy Frenzy"] = "spell_nature_bloodlust",
	["Harvest Soul"] = "spell_shadow_curseofachimonde",
	["Stomp"] = "ability_warstomp",
	["Flesh Rot"] = "ability_ghoulfrenzy",
	["Slime"] = "spell_nature_abolishmagic",
	["Test Sunder Armor"] = "ability_warrior_sunder",
	["Wildvine Potion"] = "inv_misc_herb_17",
	["Lily Root"] = "temp",
	["Healthstone"] = "inv_stone_04",
	["Greater Healthstone"] = "inv_stone_04",
	["Aegis Heal"] = "temp",
	["Oracular Heal"] = "spell_holy_lesserheal02",
	["Warrior's Resolve"] = "inv_boots_plate_03",
	["Rejuvenation Potion"] = "mail_gmicon",
	["Heroism"] = "spell_holy_mindvision",
	["Lava Shield"] = "spell_fire_immolation",
	["Breath"] = "spell_fire_fire",
	["Guillotine"] = "ability_warrior_punishingblow",
	["Gahz'ranka Slam"] = "ability_devour",
	["Thousand Blades"] = "inv-sword_53",
	["Wide Slash"] = "ability_warrior_cleave",
	["Quake"] = "temp",
	["Vicious Bite"] = "ability_racial_cannibalize",
	["Sweep"] = "spell_nature_thorns",
	["Unstable Concoction"] = "spell_fire_incinerate",
	["Shadow Bolt Whirl"] = "spell_shadow_shadowbolt",
	["Eyebeam"] = "spell_fire_fireball02",
	["Boulder"] = "spell_frost_stun",
	["Lightning Blast"] = "spell_nature_lightning",
	["Massive Tremor"] = "ability_smash",
	["Dark Strike"] = "spell_shadow_ritualofsacrifice",
	["Forked Lightning"] = "spell_nature_chainlightning",
	["Rough Copper Bomb"] = "spell_fire_selfdestruct",
	["Big Bronze Bomb"] = "inv_musket_01",
	["Big Iron Bomb"] = "spell_fire_selfdestruct",
	["Fiery Blaze"] = "spell_fire_selfdestruct",
	["Arcane Missile"] = "spell_nature_starfall",
	["Fire Strike"] = "spell_shadow_shadowbolt",
	["Coarse Dynamite"] = "spell_fire_selfdestruct",
	["Solid Dynamite"] = "inv_fabric_silk_01",
	["Hi-Explosive Bomb"] = "inv_battery_01",
	["Goblin Sapper Charge"] = "spell_fire_selfdestruct",
	["Fiery Weapon"] = "temp",
	["Venomhide Poison"] = "ability_poisons",
	["Linken's Boomerang"] = "inv_weapon_shortblade_10",
	["Dragonbreath Chili"] = "inv_misc_organ_06",
	["Numbing Pain"] = "spell_nature_corrosivebreath",
	["Demonfork"] = "spell_shadow_lifedrain02",
	["Smokey's Lighter"] = "spell_fire_incinerate",
	["Crest of Retribution"] = "inv_shield_19",
	["Ramstein's Lightning Bolts"] = "spell_lightning_lightningbolt01",
	["Wound"] = "ability_gouge",
	["Ez-Thro Dynamite"] = "inv_fabric_wool_01",
	["Arcane Detonation"] = "spell_arcane_starfire",
	["Jeklik's Crushing Blow"] = "ability_gouge",
	["Shard of the Fallen Star"] = "spell_fire_fireball02",
	["Flaming Cannonball"] = "spell_lightning_lightningbolt01",
	["Flaming Shell"] = "spell_lightning_lightningbolt01",
	["Wild Bite"] = "ability_physical_taunt",
	["Frostbrand Attack"] = "spell_frost_frostbrand",
	["Lifesteal"] = "spell_shadow_chilltouch",
	["Lightning"] = "spell_lightning_lightningbolt01",
	["Frost Arrow"] = "spell_frost_frostbolt02",
	["Frost Blast"] = "spell_frost_freezingbreath",
	["Fireblast"] = "spell_fire_flamebolt",
	["Bear Down"] = "ability_warrior_charge",
	["Iron Grenade"] = "spell_fire_selfdestruct",
	["Cloaking"] = "spell_nature_invisibilty",
	["Stoneshield"] = "inv_potion_67",
	["Flee"] = "spell_magic_polymorphchicken",
	["Fury of the Bogling"] = "spell_nature_strength",
	["Screams of the Past"] = "spell_shadow_impphaseshift",
	["Fishliver Oil"] = "inv_misc_fish_06",
	["Health"] = "inv_potion_44",
	["Sleepy"] = "spell_nature_sleep",
	["Party Time!"] = "spell_shadow_darksummoning",
	["Healthy Spirit"] = "spell_holy_magicalsentry",
	["Zeal"] = "spell_holy_innerfire",
	["Julie's Blessing"] = "spell_holy_renew",
	["Mithril Shield Spike"] = "inv_ingot_08",
	["Uther's Light Effect"] = "spell_holy_powerwordshield",
	["Spiritual Domination"] = "spell_fire_incinerate",
	["Abolish Disease Effect"] = "spell_nature_nullifydisease",
	["Static Barrier"] = "spell_nature_lightningshield",
	["Admiral's Hat"] = "spell_magic_featherfall",
	["Fearless"] = "ability_warrior_battleshout",
	["Gnomish Rocket Boots"] = "spell_fire_fire",
	["Lesser Intellect"] = "inv_potion_10",
	["Gnomish Death Ray"] = "spell_shadow_shadowbolt",
	["Blazing Emblem"] = "spell_fire_firearmor",
	["Greater Intellect"] = "inv_potion_10",
	["Crystal Restore"] = "inv_misc_gem_diamond_02",
	["Crystal Force"] = "inv_misc_gem_crystal_02",
	["Lord General's Sword"] = "ability_racial_avatar",
	["Burst of Knowledge"] = "inv_jewelry_amulet_07",
	["Agamaggan's Strength"] = "spell_nature_strength",
	["Orb of Deception"] = "spell_shadow_antishadow",
	["Agamaggan's Agility"] = "spell_nature_windfury",
	["Destiny"] = "spell_nature_strength",
	["Mark of the Dragon Lord"] = "inv_misc_head_dragon_01",
	["Argent Dawn"] = "spell_holy_devotionaura",
	["Argent Avenger"] = "spell_lightning_lightningbolt01",
	["Skullforge Brand"] = "spell_shadow_gathershadows",
	["Major Spellstone"] = "inv_misc_gem_sapphire_01",
	["Blessed Sunfruit"] = "inv_misc_fork&knife",
	["Blessed Sunfruit Juice"] = "inv_drink_07",
	["Piccolo of the Flaming Fire"] = "inv_misc_flute_01",
	["Fel Energy"] = "spell_shadow_psychicscream",
	["Restore Life"] = "inv_misc_orb_03",
	["Frenzy Effect"] = "inv_misc_monsterclaw_03",
	["Scarlet Illusion"] = "spell_holy_prayerofhealing",
	["Enchant Boots - Greater Agilit"] = "inv_misc_note_01",
	["Rumsey Rum"] = "inv_drink_03",
	["Earthshaker"] = "inv_mace_02",
	["Razorlash Root"] = "inv_misc_herb_07",
	["Mark of the Chosen Effect"] = "inv_jewelry_talisman_08",
	["Heated Ground"] = "spell_fire_fire",
	["Eskhandar's Rage"] = "inv_misc_monsterclaw_03",
	["Gordok Ogre Suit"] = "inv_chest_chain_14",
	["World Enlarger"] = "inv_gizmo_04",
	["Shadow Reflector"] = "spell_shadow_antishadow",
	["Mark of Frost"] = "spell_frost_chainsofice",
	["Evil Twin"] = "spell_shadow_charm",
	["Berserker Rage Effect"] = "temp",
	["Alterac Spring Water"] = "inv_drink_07",
	["Sayge's Dark Fortune of Spirit"] = "inv_misc_orb_02",
	["Sayge's Dark Fortune of Armor"] = "inv_misc_orb_02",
	["Speed Slash"] = "ability_ghoulfrenzy",
	["Mar'li's Brain Boost"] = "inv_zulgurubtrinket",
	["Master Angler"] = "inv_misc_fish_04",
	["Prayer Beads Blessing"] = "inv_jewelry_necklace_11",
	["Greater Dreamless Sleep"] = "spell_nature_sleep",
	["Nimble Healing Touch"] = "spell_nature_regenerate",
	["Massive Destruction"] = "spell_fire_windsofwoe",
	["Rapid Healing"] = "spell_holy_healingaura",
	["Pagle's Broken Reel"] = "spell_frost_wizardmark",
	["Pirate Costume"] = "inv_helmet_66",
	["Skeleton Costume"] = "spell_shadow_raisedead",
	["Bat Costume"] = "ability_hunter_pet_bat",
	["Ghost Costume"] = "spell_shadow_coneofsilence",
	["Wisp Costume"] = "spell_nature_wispsplode",
	["Noxious Breath"] = "spell_shadow_lifedrain02",
	["Hallow's End Candy"] = "temp",
	["Healing of the Ages"] = "spell_nature_healingwavegreater",
	["Rumsey Rum Light"] = "inv_drink_08",
	["Mark of Nature"] = "spell_nature_spiritarmor",
	["Enchant Gloves - Frost Power"] = "inv_enchant_shardbrilliantlarge",
	["Enlarge"] = "spell_nature_strength",
	["Attack Order"] = "ability_hunter_snipershot",
	["Narain!"] = "inv_helmet_63",
	["Rumsey Rum Dark"] = "inv_drink_04",
	["Poison Stinger"] = "inv_misc_monstertail_03",
	["Mystical Disjunction"] = "spell_shadow_siphonmana",
	["Spell Blasting"] = "spell_shadow_siphonmana",
	["Vekniss Catalyst"] = "ability_creature_poison_02",
	["Sand Blast"] = "spell_nature_cyclone",
	["Obsidian Insight"] = "inv_misc_ahnqirajtrinket_04",
	["Chitinous Spikes"] = "inv_misc_ahnqirajtrinket_02",
	["Mistletoe"] = "spell_nature_healingtouch",
	["Insight of the Qiraji"] = "inv_qirajidol_death",
	["Cologne"] = "inv_valentinecolognebottle",
	["Curse of the Elemental Lord"] = "spell_fire_lavaspawn",
	["Crusader's Wrath"] = "temp",
	["Elixir of Resistance"] = "inv_potion_21",
	["Lay Hands"] = "inv_belt_22",
	["Fire-toasted Bun"] = "inv_misc_food_11",
	["Midsummer Sausage"] = "inv_misc_food_53",
	["Toasted Smorc"] = "inv_summerfest_smorc",
	["Elderberry Pie"] = "inv_misc_food_10",
	["Breath of Fire"] = "spell_fire_incinerate",
	["Sheen of Zanza"] = "inv_potion_29",
	["Elemental Devastation"] = "spell_fire_elementaldevastation",
	["Infected Wound"] = "spell_nature_nullifydisease",
	["Consuming Shadows"] = "spell_shadow_haunting",
	["Lingering Presence"] = "inv_helmet_06",
	["Health Regeneration"] = "spell_holy_healingaura",
	["Stamina"] = "spell_nature_unyeildingstamina",
	["Shockwave"] = "spell_shadow_impphaseshift",
	["Arcane Potency"] = "spell_arcane_starfire",
	["Earth Rumble"] = "spell_nature_natureswrath",
	["Defibrillated!"] = "spell_nature_purge",
	["Crusader Strike"] = "spell_holy_holysmite",
	["Arcane Might"] = "spell_holy_mindsooth",
	["Arcane Burst"] = "spell_nature_wispsplode",
	["Swoop"] = "ability_warrior_cleave",
	["Shadowflame"] = "temp",
	["Blood Heal"] = "spell_holy_blessedlife",
	["Acid Splash"] = "spell_fire_felcano",
	["Terrifying Screech"] = "spell_shadow_summonimp",
	["Mana Regen Proc"] = "inv_gauntlets_60",
	["Daze"] = "spell_frost_stun",
	["Ground Smash"] = "inv_gauntlets_05",
	["Diminish Soul"] = "spell_holy_consumemagic",
	["Virulent Poison"] = "spell_nature_corrosivebreath",
	["Lash"] = "ability_druid_disembowel",
	["Aura of Vengeance"] = "spell_shadow_siphonmana",
	["Focus"] = "spell_holy_searinglight",
	["Stun"] = "spell_frost_stun",
	["Mortal Cleave"] = "ability_warrior_savageblow",
	["Petrification"] = "inv_potion_26",
	["Fury"] = "spell_holy_blessingofstrength",
	["Paralyze"] = "spell_shadow_charm",
	["Cripple"] = "spell_shadow_cripple",
	["Disease Cloud"] = "spell_nature_abolishmagic",
	["Haste"] = "spell_nature_invisibilty",
	["Fel Energy Cosmetic"] = "spell_fire_felfire",
	["Wild Magic"] = "spell_shadow_charm",
	["Frost Breath"] = "temp",
	["Feral Charge Effect"] = "ability_hunter_pet_bear",
	["Shadow Infusion"] = "spell_shadow_shadowworddominate",
	["Flame Strike"] = "spell_fire_selfdestruct",
	["Snap Kick"] = "ability_kick",
	["Fire Festival Fury"] = "inv_summerfest_fireflower",
	["Domination"] = "spell_shadow_shadowworddominate",
	["Chilling Touch"] = "spell_frost_frostarmor",
	["Dense Dynamite"] = "inv_fabric_purplefire_01",
	["Increased Intellect"] = "inv_misc_organ_03",
	["Fire Reflector"] = "spell_fire_sealoffire",
	["Restless Strength"] = "temp",
	["Invisibility"] = "inv_potion_18",
	["Summon Infernals"] = "temp",
	["Mind Exhaustion"] = "spell_shadow_teleport",
	["Berserker Charge"] = "ability_warrior_charge",
	["Dark Rune"] = "inv_misc_rune_04",
	["Grace of Earth"] = "ability_physical_taunt",
	["Black Amnesty"] = "spell_fire_flamebolt",
	["Dismember"] = "ability_backstab",
	["Trip"] = "ability_rogue_trip",
	["Fire Shield II"] = "spell_fire_immolation",
	["Full Speed"] = "ability_warrior_innerrage",
	["Fire Shield III"] = "spell_fire_immolation",
	["Fire Shield IV"] = "spell_fire_immolation",
	["Fire Shield Effect II"] = "spell_fire_immolation",
	["Fire Shield Effect IV"] = "spell_fire_immolation",
	["Touch of Death"] = "spell_shadow_unsummonbuilding",
	["Presence of Death"] = "spell_shadow_shadetruesight",
	["Ice Claw"] = "spell_frost_iceclaw",
	["Frenzied Command"] = "ability_racial_bloodrage",
	["Glacial Roar"] = "spell_frost_frostnova",
	["Rabies"] = "spell_holy_harmundeadaura",
	["Crazed Hunger"] = "ability_racial_cannibalize",
	["Sapper Explode"] = "spell_fire_selfdestruct",
	["Quick Bloodlust"] = "spell_nature_bloodlust",
	["Curse of Thule"] = "spell_shadow_shadowpact",
	["Life Harvest"] = "spell_shadow_requiem",
	["Agonizing Pain"] = "ability_ghoulfrenzy",
	["Savage Rage"] = "spell_shadow_unholyfrenzy",
	["Blessing of Thule"] = "spell_shadow_fingerofdeath",
	["Violent Shield"] = "spell_shadow_mindbomb",
	["Slow Poison"] = "spell_nature_slowpoison",
	["Dark Sludge"] = "spell_shadow_creepingplague",
	["Drink Minor Potion"] = "spell_holy_heal",
	["Potion Strength II"] = "spell_nature_strength",
	["Rage of Thule"] = "spell_shadow_unholyfrenzy",
	["Deadly Leech Poison"] = "spell_nature_nullifypoison",
	["Ward of the Eye"] = "spell_totem_wardofdraining",
	["Soul Rend"] = "spell_shadow_teleport",
	["Fiend Fury"] = "spell_shadow_unholyfrenzy",
	["Tainted Howl"] = "spell_nature_corrosivebreath",
	["Plague Mind"] = "spell_shadow_callofbone",
	["Enchanted Quickness"] = "spell_nature_invisibilty",
	["Wail of Nightlash"] = "spell_shadow_possession",
	["Felstrom Resurrection"] = "spell_totem_wardofdraining",
	["Frenzied Rage"] = "spell_shadow_unholyfrenzy",
	["Enraging Memories"] = "spell_shadow_unholyfrenzy",
	["Deafening Screech"] = "spell_shadow_auraofdarkness",
	["Distracting Pain"] = "ability_racial_cannibalize",
	["Paralyzing Poison"] = "ability_poisonsting",
	["Minion of Morganth"] = "spell_totem_wardofdraining",
	["Bloodscalp Pet"] = "spell_nature_spiritwolf",
	["Summon Dalaran Serpent"] = "ability_ambush",
	["Skullsplitter Pet"] = "spell_nature_spiritwolf",
	["Battle Fury"] = "ability_racial_bloodrage",
	["Crystal Gaze"] = "ability_golemthunderclap",
	["Crystalline Slumber"] = "spell_nature_sleep",
	["Improved Blocking III"] = "spell_fire_firearmor",
	["Improved Blocking"] = "spell_fire_firearmor",
	["Sling Mud"] = "spell_nature_sleep",
	["Summon Spirit of Old"] = "spell_nature_purge",
	["Summon Shield Guard"] = "spell_nature_purge",
	["Summon Theurgist"] = "spell_nature_purge",
	["Ward of Laze"] = "spell_totem_wardofdraining",
	["Argus Shadow Mage Transform"] = "spell_shadow_unsummonbuilding",
	["Trelane's Freezing Touch"] = "spell_shadow_unsummonbuilding",
	["Summon Helcular's Puppets"] = "spell_shadow_haunting",
	["Resupply"] = "spell_misc_drink",
	["Encasing Webs"] = "spell_nature_earthbind",
	["Wither Touch"] = "spell_nature_drowsy",
	["Quick Flame Ward"] = "spell_fire_sealoffire",
	["Quick Frost Ward"] = "spell_fire_sealoffire",
	["Crystal Flash"] = "spell_shadow_teleport",
	["Voidwalker"] = "spell_shadow_summonvoidwalker",
	["Summon Living Flame"] = "spell_fire_fire",
	["Battle Command"] = "ability_racial_bloodrage",
	["Eject Sneed"] = "spell_fire_fire",
	["Bloodsail Companion"] = "ability_eyeoftheowl",
	["Cookie's Cooking"] = "spell_holy_heal",
	["Molten Metal"] = "spell_fire_fireball",
	["Fanatic Blade"] = "spell_fire_fire",
	["Cursed Blade"] = "spell_nature_drowsy",
	["Razor Mane"] = "spell_nature_thorns",
	["Claw Grasp"] = "inv_misc_birdbeck_02",
	["Quick Sidestep"] = "spell_nature_invisibilty",
	["Savagery"] = "ability_whirlwind",
	["Fade Out"] = "spell_nature_invisibilty",
	["Miring Mud"] = "spell_nature_stranglevines",
	["Threatening Growl"] = "ability_racial_cannibalize",
	["Stone Skin"] = "ability_golemthunderclap",
	["Crazed"] = "spell_shadow_spectralsight",
	["Summon Crimson Cannon"] = "ability_golemstormbolt",
	["Nimble Reflexes"] = "ability_meleedamage",
	["Kodo Stomp"] = "ability_warstomp",
	["Healing Ward IV Passive"] = "spell_holy_restoration",
	["Rhahk'Zor Slam"] = "inv_gauntlets_05",
	["Faded"] = "spell_nature_invisibilty",
	["Smite Stomp"] = "ability_warstomp",
	["Smite Slam"] = "inv_gauntlets_05",
	["Earthbind Totem Passive"] = "spell_nature_strengthofearthtotem02",
	["Razormane Wolf"] = "ability_druid_rake",
	["Ground Tremor"] = "spell_nature_earthquake",
	["Sling Dirt"] = "spell_nature_sleep",
	["Overseer's Poison"] = "spell_nature_corrosivebreath",
	["Intimidating Growl"] = "ability_racial_cannibalize",
	["Savannah Cub"] = "ability_druid_rake",
	["Salt Flats Racer Speed"] = "inv_misc_gear_01",
	["Piercing Shot"] = "ability_searingarrow",
	["Weak Poison Proc"] = "spell_nature_corrosivebreath",
	["Corrupted Strength"] = "spell_holy_harmundeadaura",
	["Corrupted Intellect"] = "spell_holy_harmundeadaura",
	["Foul Chill"] = "spell_frost_wisp",
	["Hide"] = "ability_stealth",
	["Shadowhorn Charge"] = "spell_nature_drowsy",
	["Gift of the Xavian"] = "spell_holy_flashheal",
	["Shadowstalker Slash"] = "ability_cheapshot",
	["Overwhelming Stench"] = "spell_shadow_animatedead",
	["Weak Frostbolt"] = "spell_frost_frostbolt02",
	["Lightning Barrier"] = "spell_nature_lightningshield",
	["Fire Shot"] = "ability_searingarrow",
	["Haunting Spirits"] = "spell_shadow_blackplague",
	["Wild Rage"] = "spell_shadow_grimward",
	["Arugal's Gift"] = "spell_shadow_chilltouch",
	["Toxic Saliva"] = "spell_nature_corrosivebreath",
	["Summon Lupine Delusions"] = "spell_shadow_teleport",
	["Diving Sweep"] = "ability_warrior_cleave",
	["Nature Protection Potion"] = "inv_misc_herb_11",
	["Lightning Hide"] = "spell_nature_lightningshield",
	["Summon Harvester Swarm"] = "ability_stealth",
	["Heal Brother"] = "spell_nature_healingwavegreater",
	["Call Bleak Worg"] = "spell_shadow_chilltouch",
	["Call Slavering Worg"] = "spell_shadow_chilltouch",
	["Call Lupine Horror"] = "spell_shadow_chilltouch",
	["Potion Toss"] = "spell_misc_drink",
	["Wailing Dead"] = "spell_shadow_possession",
	["Inferno Shell"] = "spell_fire_selfdestruct",
	["Shared Bondage"] = "spell_shadow_unsummonbuilding",
	["Gift of Ragnaros"] = "spell_fire_fire",
	["Decayed Agility"] = "spell_holy_harmundeadaura",
	["Localized Toxin"] = "spell_nature_corrosivebreath",
	["Compact Harvest Reaper"] = "spell_shadow_metamorphosis",
	["Summon Treant Ally"] = "spell_nature_forceofnature",
	["Nullify Mana"] = "spell_shadow_darkritual",
	["Area Burn"] = "spell_fire_selfdestruct",
	["Tetanus"] = "spell_holy_harmundeadaura",
	["Spirit Decay"] = "spell_holy_harmundeadaura",
	["Druid's Slumber"] = "spell_nature_sleep",
	["Silithid Pox"] = "spell_nature_nullifydisease",
	["Befuddlement"] = "spell_shadow_mindsteal",
	["Tremor Totem Passive"] = "spell_nature_tremortotem",
	["Thorns Aura"] = "spell_nature_thorns",
	["Surprise Attack"] = "ability_cheapshot",
	["Poison Cleansing Totem Passive"] = "spell_nature_poisoncleansingtotem",
	["Disease Cleansing Totem Passiv"] = "spell_nature_diseasecleansingtotem",
	["Grounding Totem Passive"] = "spell_nature_groundingtotem",
	["Explosive Sheep"] = "spell_shadow_metamorphosis",
	["Savannah Cubs"] = "ability_druid_rake",
	["Wandering Plague"] = "spell_shadow_callofbone",
	["Strong Cleave"] = "ability_warrior_cleave",
	["Lethal Toxin"] = "spell_nature_corrosivebreath",
	["Elemental Protection Totem"] = "spell_nature_nullward",
	["Elemental Protection Totem Aur"] = "spell_nature_nullward",
	["Lava Spout Totem Passive"] = "spell_fire_selfdestruct",
	["Summon Earth Rumbler"] = "spell_nature_earthquake",
	["Summon Wind Howler"] = "spell_nature_cyclone",
	["Summon Tamed Battleboar"] = "spell_magic_polymorphpig",
	["Summon Tamed Hyena"] = "ability_druid_swipe",
	["Trap"] = "inv_potion_01",
	["Mana Spike"] = "spell_holy_heal",
	["Purity"] = "spell_holy_holybolt",
	["Summon Aqua Guardian"] = "spell_frost_wisp",
	["Earthgrab Totem"] = "spell_nature_naturetouchdecay",
	["Summon Moonstalker Runt"] = "ability_druid_supriseattack",
	["Summon Crawler"] = "inv_misc_birdbeck_02",
	["Low Swipe"] = "ability_golemthunderclap",
	["Dynamite"] = "spell_fire_selfdestruct",
	["Poisoned Shot"] = "ability_poisons",
	["Summon Kurzen Mindslave"] = "spell_arcane_blink",
	["Flame Spike"] = "spell_fire_selfdestruct",
	["Summon Panthers"] = "ability_mount_blackpanther",
	["Smoke Bomb"] = "ability_stealth",
	["Ward of Zanzil"] = "spell_totem_wardofdraining",
	["Summon Fen Dweller"] = "spell_nature_abolishmagic",
	["Stealth (TEST)"] = "ability_stealth",
	["Unholy Shield"] = "spell_shadow_detectlesserinvisibility",
	["Summon Illusionary Phantasm"] = "spell_fire_sealoffire",
	["Deep Sleep"] = "spell_nature_sleep",
	["Searing Flames"] = "spell_fire_immolation",
	["Lock Down"] = "inv_gizmo_01",
	["Ink Spray"] = "spell_nature_sleep",
	["Summon Rift Traveler"] = "spell_shadow_antishadow",
	["Summon Swamp Spirit"] = "spell_nature_abolishmagic",
	["Jumping Lightning"] = "spell_nature_lightning",
	["Shadow Shell"] = "spell_shadow_antishadow",
	["Radiation Bolt"] = "spell_holy_harmundeadaura",
	["Irradiated"] = "spell_nature_abolishmagic",
	["Beast Tracking"] = "ability_tracking",
	["Radiation Cloud"] = "spell_shadow_corpseexplode",
	["Silithid Swarm"] = "spell_shadow_auraofdarkness",
	["Pacify"] = "ability_seal",
	["Flame Spray"] = "spell_fire_fire",
	["Create Weegli's Barrel"] = "inv_misc_bowl_01",
	["Grab Weapon"] = "ability_warrior_disarm",
	["Battle Net"] = "ability_ensnare",
	["Spirit of Kirith"] = "spell_frost_wisp",
	["Lag"] = "inv_gizmo_01",
	["Summon Dupe Bug"] = "spell_shadow_auraofdarkness",
	["Crowd Pummel"] = "inv_gauntlets_04",
	["Soul Bite"] = "spell_shadow_siphonmana",
	["Summon Witherbark Felhunter"] = "spell_shadow_summonfelhunter",
	["Flamespit"] = "spell_fire_flamebolt",
	["Megavolt"] = "spell_nature_chainlightning",
	["Chain Bolt"] = "spell_nature_chainlightning",
	["Radiation Poisoning"] = "spell_shadow_corpseexplode",
	["Dark Iron Land Mine"] = "spell_shadow_metamorphosis",
	["Steam Jet"] = "ability_hibernation",
	["Muscle Tear"] = "ability_gouge",
	["Summon Oozeling"] = "spell_nature_abolishmagic",
	["Curse of Tuten'kash"] = "spell_nature_drowsy",
	["Summon Shadowcaster"] = "spell_shadow_raisedead",
	["Acid of Hakkar"] = "spell_nature_acid_01",
	["Summon Skeletal Servant"] = "spell_shadow_raisedead",
	["Hex of Jammal'an"] = "spell_totem_wardofdraining",
	["Atal'ai Skeleton Totem"] = "spell_shadow_raisedead",
	["Frailty"] = "spell_shadow_animatedead",
	["Hukku's Guardians"] = "spell_shadow_summonvoidwalker",
	["Wing Flap"] = "spell_nature_earthbind",
	["Deep Slumber"] = "spell_shadow_cripple",
	["Putrid Stench"] = "spell_shadow_callofbone",
	["Jadefire"] = "spell_fire_sealoffire",
	["Curse of the Deadwood"] = "spell_shadow_gathershadows",
	["Haste Aura"] = "spell_holy_fistofjustice",
	["Dire Growl"] = "ability_racial_cannibalize",
	["Summon Spawn of Bael'Gar"] = "spell_fire_lavaspawn",
	["Seal of Sacrifice"] = "spell_holy_sealofsacrifice",
	["Rebuild"] = "spell_shadow_lifedrain",
	["Flaying Vine"] = "ability_warrior_cleave",
	["Tunneler Acid"] = "spell_nature_acid_01",
	["Molten Blast"] = "spell_fire_fire",
	["Resist Fire"] = "spell_fire_firearmor",
	["Scarshield Portal"] = "spell_arcane_teleportorgrimmar",
	["Cleave Armor"] = "ability_warrior_savageblow",
	["Fury of Ragnaros"] = "spell_holy_mindsooth",
	["Nagmara's Vanish"] = "temp",
	["Enveloping Web"] = "spell_nature_earthbind",
	["Explosive Shot"] = "spell_fire_fireball02",
	["Drink Healing Potion"] = "spell_holy_heal",
	["Throw Wrench"] = "inv_misc_wrench_01",
	["Avatar of Flame"] = "spell_fire_firebolt",
	["Head Smash"] = "ability_devour",
	["Fiery Burst"] = "spell_fire_firebolt",
	["Flamecrack"] = "spell_fire_fire",
	["Moonflare Totem"] = "spell_fire_sealoffire",
	["Moonflare"] = "spell_arcane_starfire",
	["Festering Rash"] = "spell_nature_nullifydisease",
	["Flame Buffet Totem"] = "spell_fire_searingtotem",
	["Superior Healing Ward Passive"] = "spell_holy_restoration",
	["Ice Blast"] = "spell_frost_freezingbreath",
	["Flames of the Black Flight"] = "spell_fire_sealoffire",
	["Curse of the Firebrand"] = "ability_creature_cursed_03",
	["Crystallize"] = "spell_shadow_teleport",
	["Cadaver Worms"] = "spell_shadow_requiem",
	["Empower Will"] = "ability_warrior_battleshout",
	["Mana Tide"] = "spell_holy_stoicism",
	["Debilitating Touch"] = "spell_shadow_fingerofdeath",
	["Haunting Phantoms"] = "spell_shadow_blackplague",
	["Maggot Slime"] = "spell_shadow_creepingplague",
	["Ghoul Plague"] = "spell_holy_harmundeadaura",
	["Mother's Milk"] = "ability_creature_poison_02",
	["Web Explosion"] = "ability_ensnare",
	["Stun Bomb"] = "spell_fire_selfdestruct",
	["Toxic Bolt"] = "spell_nature_corrosivebreath",
	["Tainted Mind"] = "spell_shadow_shadowpact",
	["Charged Arcane Bolt"] = "spell_arcane_starfire",
	["Piercing Screech"] = "spell_shadow_unsummonbuilding",
	["Summon Zombie"] = "spell_shadow_raisedead",
	["Add Lightning Dam - Weap 03"] = "temp",
	["Mend Dragon"] = "spell_shadow_lifedrain",
	["Flamebreak"] = "spell_holy_excorcism_02",
	["Draining Blow"] = "spell_shadow_chilltouch",
	["Enchanting Lullaby"] = "spell_shadow_soothingkiss",
	["Flash Freeze"] = "spell_frost_frostnova",
	["Bone Shards"] = "spell_shadow_scourgebuild",
	["Decay"] = "spell_shadow_contagion",
	["Shadow Barrier"] = "spell_shadow_antishadow",
	["Summon Scarlet Hound"] = "ability_hunter_pet_wolf",
	["Fatal Sting"] = "spell_nature_corrosivebreath",
	["Resist Arcane"] = "spell_arcane_blink",
	["Seal of Protection"] = "spell_holy_sealofprotection",
	["Maggot Goo"] = "ability_creature_poison_02",
	["Scald"] = "spell_fire_fireball",
	["Crusader's Hammer"] = "spell_holy_sealofmight",
	["Bone Smelt"] = "spell_shadow_raisedead",
	["Hand of Thaurissan"] = "spell_fire_fireball",
	["Corpse Explosion"] = "spell_shadow_corpseexplode",
	["Summon Risen Lackey"] = "spell_shadow_raisedead",
	["Altered Cauldron Toxin"] = "spell_holy_excorcism_02",
	["Diseased Spit"] = "spell_shadow_creepingplague",
	["Earthborer Acid"] = "spell_nature_acid_01",
	["Kirtonos Gargoyle Passive"] = "inv_shield_04",
	["Call Bloodshot"] = "ability_druid_rake",
	["Dark Plague"] = "spell_nature_nullifydisease",
	["Incapacitating Shout"] = "ability_warrior_warcry",
	["Dismounting Shot"] = "spell_shadow_teleport",
	["Dismounting Blast"] = "spell_shadow_teleport",
	["Curse of the Darkmaster"] = "spell_shadow_antishadow",
	["Holy Cleave"] = "ability_warrior_cleave",
	["Frost"] = "spell_frost_frostshock",
	["Summon Lava Spawn"] = "spell_shadow_sealofkings",
	["Magic Grounding"] = "spell_holy_sealofsalvation",
	["Inspire"] = "ability_warrior_battleshout",
	["Flame Spear"] = "ability_throw",
	["Calm Dragonkin"] = "spell_nature_invisibilitytotem",
	["Destroy Egg"] = "inv_misc_monsterclaw_02",
	["Fatal Bite"] = "ability_backstab",
	["Magma Blast"] = "spell_fire_flameshock",
	["Magic Reflection"] = "spell_frost_frostshock",
	["Aegis of Ragnaros"] = "spell_shadow_antishadow",
	["Corrosive Venom Spit"] = "spell_nature_corrosivebreath",
	["Sleepwalk"] = "spell_shadow_detectinvisibility",
	["Dominate Mind"] = "spell_shadow_shadowworddominate",
	["Summon Karang's Banner Aura"] = "temp",
	["Damage Shield"] = "spell_shadow_antishadow",
	["Putrid Breath"] = "spell_holy_harmundeadaura",
	["Manastorm"] = "spell_frost_icestorm",
	["Intense Heat"] = "spell_fire_fire",
	["Goblin Land Mine"] = "spell_shadow_metamorphosis",
	["Thorn Volley"] = "spell_nature_natureswrath",
	["Aqua Jet"] = "spell_frost_chillingblast",
	["Twisted Tranquility"] = "spell_nature_tranquility",
	["Repulsive Gaze"] = "ability_golemthunderclap",
	["Corrupt Forces of Nature"] = "spell_nature_forceofnature",
	["Chaotic Focus"] = "spell_fire_sealoffire",
	["Riptide"] = "ability_warrior_disarm",
	["Submersion"] = "spell_shadow_demonbreath",
	["Massive Geyser"] = "spell_frost_summonwaterelemental",
	["Water"] = "spell_frost_summonwaterelemental",
	["Aura of Flames"] = "spell_fire_fire",
	["Commanding Shout"] = "ability_warrior_rallyingcry",
	["Intense Pain"] = "spell_shadow_shadowwordpain",
	["Ice Nova"] = "spell_frost_frostnova",
	["Bruising Blow"] = "ability_rogue_kidneyshot",
	["Wither"] = "spell_nature_nullifydisease",
	["Harden Skin"] = "spell_nature_skinofearth",
	["Summon Hydroling"] = "spell_frost_chillingblast",
	["Booze Spit"] = "inv_drink_05",
	["Eye of Immol'thar"] = "spell_shadow_antimagicshell",
	["Grasping Vines"] = "ability_golemthunderclap",
	["Corrupted Stamina"] = "spell_holy_harmundeadaura",
	["Entropic Sting"] = "spell_nature_callstorm",
	["Demoralize"] = "ability_warrior_warcry",
	["Fool's Plight"] = "spell_magic_polymorphchicken",
	["Dragonbane"] = "ability_warrior_savageblow",
	["Cleanse Nova"] = "spell_holy_holybolt",
	["Powerful Healing Ward"] = "spell_holy_restoration",
	["Blood Funnel"] = "spell_shadow_lifedrain",
	["Wings of Despair"] = "spell_shadow_psychicscream",
	["Abomination Spit"] = "spell_nature_corrosivebreath",
	["Sweeping Slam"] = "ability_devour",
	["Grace of Air"] = "spell_nature_invisibilitytotem",
	["Arcane Eruption"] = "spell_arcane_portalironforge",
	["Energize"] = "spell_nature_cyclone",
	["Frenzy Aura"] = "spell_holy_fistofjustice",
	["Dispel"] = "spell_holy_dispelmagic",
	["Tranquil Air"] = "spell_nature_brilliance",
	["Itch"] = "spell_nature_naturetouchdecay",
	["Piercing Shriek"] = "spell_shadow_deathscream",
	["Burrow"] = "ability_vanish",
	["Summon Player"] = "inv_misc_head_human_02",
	["Shadow Mark"] = "spell_shadow_shadowward",
	["Spit"] = "spell_nature_corrosivebreath",
	["Flash"] = "spell_nature_lightningbolt",
	["Static Field"] = "spell_shadow_spectralsight",
	["Scourge Strike"] = "spell_lightning_lightningbolt01",
	["Ball Lightning"] = "spell_lightning_lightningbolt01",
	["Veil of Darkness"] = "spell_shadow_gathershadows",
	["Aura of Agony"] = "spell_shadow_curseofsargeras",
	["Poison Charge"] = "spell_nature_corrosivebreath",
	["Spider Web"] = "spell_nature_earthbind",
	["Blood Tap"] = "spell_shadow_lifedrain",
	["Chill"] = "spell_frost_icestorm",
	["Mark of Korth'azz"] = "spell_shadow_metamorphosis",
	["Web Spray"] = "ability_ensnare",
	["Decrepit Fever"] = "ability_creature_disease_03",
	["Poison Spray"] = "spell_nature_corrosivebreath",
	["Putrid Bite"] = "ability_creature_disease_03",
	["Slime Bolt"] = "spell_nature_corrosivebreath",
	["Eye Beam"] = "spell_nature_callstorm",
	["Ground Rupture"] = "spell_nature_earthquake",
	["Poison Cloud"] = "spell_nature_naturetouchdecay",
	["Gift of Arthas"] = "inv_misc_herb_14",
	["Dust Cloud"] = "ability_hibernation",
	["Nature Protection "] = "inv_potion_127",
	["Dark Glare"] = "spell_shadow_shadowbolt",
	["Spit Out"] = "spell_nature_drowsy",
	["Weak Poison"] = "spell_nature_corrosivebreath",
	["Sapta Sight"] = "ability_cheapshot",
	["Spirit"] = "spell_shadow_burningspirit",
	["Flametongue Attack"] = "spell_fire_flametounge",
	["Whipper Root Tuber"] = "temp",
	["Strength"] = "spell_nature_strength",
	["Earthbind"] = "spell_nature_strengthofearthtotem02",
	["Healing Stream"] = "inv_spear_04",
	["Tendon Rip"] = "ability_criticalstrike",
	["Blaze"] = "temp",
	["Throw Liquid Fire"] = "spell_fire_meteorstorm",
	["Digestive Acid"] = "ability_creature_disease_02",
	["Locust Swarm"] = "spell_nature_insectswarm",
	["Web Wrap"] = "spell_nature_web",
	["Mutating Injection"] = "spell_shadow_callofbone",
	["Terrifying Roar"] = "ability_devour",
	["Web"] = "ability_ensnare",
	["Black Sludge"] = "spell_shadow_callofbone",
	["Arcane Bolt"] = "spell_arcane_starfire",
	["Shock"] = "temp",
	["Hooked Net"] = "ability_ensnare",
	["Shadowbolt"] = "spell_lightning_lightningbolt01",
	["Blood Leech"] = "ability_racial_cannibalize",
	["Force Punch"] = "inv_gauntlets_31",
	["Lightning Cloud"] = "spell_nature_callstorm",
	["Thundercrash"] = "spell_nature_thunderclap",
	["Harsh Winds"] = "spell_nature_earthbind",
	["Stinger Spray"] = "inv_misc_monstertail_03",
	["Cloud of Disease"] = "spell_nature_abolishmagic",
	["Enveloping Winds"] = "spell_nature_cyclone",
	["Mark of Kazzak"] = "spell_shadow_antishadow",
	["King of the Gordok"] = "inv_crown_02",
	["Slip'kik's Savvy"] = "spell_holy_lesserheal02",
	["Major Healthstone"] = "inv_stone_04",
	["Intellect"] = "spell_holy_magicalsentry",
	["Tail Sweep"] = "inv_misc_monsterscales_05",
	["Wild Polymorph"] = "spell_nature_polymorph",
	["Silithyst"] = "spell_holiday_tow_spicecloud",
	["Torch"] = "ability_rogue_ambush",
	["Healing Potion"] = "inv_misc_herb_10",
	["Major Healing Potion"] = "inv_misc_herb_mountainsilversage",
	["Major Mana Potion"] = "inv_misc_herb_icecap",
	["Mana Potion"] = "inv_misc_herb_icecap",
	["Restore Mana"] = "inv_misc_herb_icecap",
	["Major Rejuvenation Potion"] = "inv_misc_herb_sansamroot",
	["Holy Strength"] = "spell_holy_blessingofstrength",
	["Earthstrike"] = "spell_nature_abolishmagic", 
	["Rogue Armor Energize"] = "trade_engineering",
	["Relentless Strikes Effect"] = "ability_warrior_decisivestrike",
	["Net"] = "inv_misc_net_01",
	["Quick Shots"] = "ability_warrior_innerrage",
	["Dazed"] = "spell_frost_stun",
	["Volatile Infection"] = "spell_holy_harmundeadaura",
	["Corrosive Acid Spit"] = "spell_nature_acid_01",
	["Poison Mind"] = "spell_nature_corrosivebreath",
	["Knockdown"] = "ability_golemthunderclap",
	["Hand of Justice"] = "inv_jewelry_talisman_01",
	["AutoAttack"] = "inv_sword_39",
	["Lightning Strike"] = "spell_holy_mindvision",
	["Thunderfury"] = "spell_nature_cyclone",
	["Fatal Wound"] = "ability_backstab",
	["Life Steal"] = "trade_engineering",
	["Crystal Charge"] = "inv_misc_gem_opal_01",
	["Demonic Rune"] = "inv_misc_rune_04",
	["Poison"] = "spell_nature_corrosivebreath",
	["Berserker Charge"] = "ability_warrior_charge",
	["Elixir of the Mongoose"] = "inv_potion_32",
	["Greater Agility"] = "inv_potion_94",
	["Speed"] = "ability_kick",
	["Mol'dar's Moxie"] = "spell_nature_massteleport",
	["Freezing Trap Effect"] = "spell_frost_chainsofice",
	["Fengus' Ferocity"] = "spell_nature_undyingstrength",
	["Flame Lash"] = "spell_fire_flameblades",
	["Swiftness of Zanza"] = "inv_potion_31",
	["Spirit of Zandalar"] = "ability_creature_poison_05",
	["Strike of the Scorpok"] = "spell_nature_forceofnature",
	["Recently Bandaged"] = "inv_misc_bandage_08",
	["Fixate"] = "spell_shadow_charm",
	["Sayge's Dark Fortune of Damage"] = "inv_misc_orb_02",
	["Sleep"] = "spell_nature_sleep",
	["Venom Sting"] = "ability_poisonsting",
	["Draw Spirit"] = "spell_shadow_summoninfernal",
	["Corrosive Acid Breath"] = "spell_nature_acid_01",
	["Greater Arcane Elixir"] = "inv_potion_25",
	["Rallying Cry of the Dragonslayer"] = "inv_misc_head_dragon_01",
	["Winterfall Firewater"] = "inv_potion_92",
	["Restore Energy"] = "inv_drink_milk_05",
	["Rumsey Rum Black Label"] = "inv_drink_04",
	["Mighty Rage"] = "ability_warrior_innerrage",
	["Withering Heat"] = "spell_fire_fire",
	["Ancient Dread"] = "spell_shadow_curseoftounges",
	["Ignite Mana"] = "spell_fire_incinerate",
	["Ground Stomp"] = "ability_warstomp",
	["Lucifron's Curse"] = "spell_shadow_blackplague",
	["Hand of Ragnaros"] = "spell_fire_fireball",
	["Incite Flames"] = "spell_fire_flameblades",
	["Magma Shackles"] = "spell_nature_earthbind",
	["Melt Armor"] = "spell_fire_immolation",
	["Serrated Bite"] = "ability_gouge",
	["Rage of Ages"] = "spell_nature_strength",
	["Ancient Hysteria"] = "spell_shadow_unholyfrenzy",
	["Shazzrah's Curse"] = "spell_shadow_antishadow",
	["Fist of Ragnaros"] = "spell_holy_sealofwrath",
	["Magma Spit"] = "spell_fire_immolation",
	["Pyroclast Barrage"] = "spell_fire_fireball02",
	["Gehennas' Curse"] = "spell_shadow_gathershadows",
	["Impending Doom"] = "spell_shadow_nightofthedead",
	["Health II"] = "inv_potion_43",
	["Battle Squawk"] = "inv_misc_birdbeck_01",
	["Noggenfogger Elixir"] = "inv_potion_83",
	["Elixir of Brute Force"] = "inv_potion_59",
	["Diamond Flask"] = "inv_drink_01",
	["Conflagration"] = "spell_fire_incinerate",
	["Living Bomb"] = "inv_enchant_essenceastralsmall",
	["Songflower Serenade"] = "spell_holy_mindvision",
	["Free Action"] = "inv_potion_04",
	["Panic"] = "spell_shadow_deathscream",
	["Increased Agility"] = "inv_gauntlets_19",
	["Fire Protection"] = "spell_fire_firearmor",
	["Magma Splash"] = "spell_fire_immolation",
	["Bloodfang"] = "spell_shadow_lifedrain",
	["Furbolg Form"] = "inv_misc_monsterclaw_04",
	["Elemental Fire"] = "spell_fire_fire",
	["Elixir of the Giants"] = "inv_potion_61",
	["Crystal Spire"] = "inv_misc_gem_stone_01",
	["Sanctuary"] = "spell_fire_sealoffire",
	["Warrior's Wrath"] = "ability_warrior_savageblow",
	["Soul Burn"] = "spell_fire_soulburn",
	["Agility"] = "inv_scroll_02",
	["Crystal Ward"] = "inv_misc_gem_ruby_02",
	["Mind Quickening"] = "spell_nature_wispheal",
	["Feed Pet Effect"] = "ability_hunter_beasttraining",
	["Faerie Fire (Feral)"] = "spell_nature_faeriefire",
	["Shadow Vulnerability"] = "spell_shadow_blackplague",
	["Expose Weakness"] = "ability_hunter_snipershot",
	["Frost Power"] = "inv_potion_03",
	["Ephemeral Power"] = "spell_holy_mindvision",
	["Unstable Power"] = "spell_lightning_lightningbolt01",
	["Netherwind Focus"] = "spell_shadow_teleport",
	["Forbearance"] = "spell_holy_removecurse",
	["Supreme Power"] = "inv_potion_41",
	["Gordok Green Grog"] = "inv_drink_03",
	["Spirit of Boar"] = "spell_nature_purge",
	["Armor"] = "inv_scroll_07",
	["Touch of Shadow"] = "spell_shadow_psychicscream",
	["Invulnerability"] = "spell_holy_divineintervention",
	["Shadow Power"] = "inv_potion_46",
	["Infallible Mind"] = "spell_ice_lament",
	["Aura of the Blue Dragon"] = "spell_shadow_siphonmana",
	["Force Reactive Disk"] = "spell_lightning_lightningbolt01",
	["Eruption"] = "spell_fire_fire",
	["Lava Burst"] = "spell_fire_volcano",
	["Wrath of Ragnaros"] = "spell_fire_soulburn",
	["Fire Blossom"] = "spell_fire_incinerate",
	["Earthquake"] = "spell_nature_earthquake",
	["Surge"] = "ability_warrior_charge",
	["Cone of Fire"] = "spell_fire_windsofwoe",
	["Lava Breath"] = "spell_fire_windsofwoe",
	["Shadow Shock"] = "spell_shadow_shadowbolt",
	["Lava"] = "spell_fire_fire",
	["Falling"] = "spell_magic_featherfall",
	["Smash"] = "ability_thunderbolt",
	["Fire Nova"] = "spell_fire_sealoffire",
	["Gift of Life"] = "inv_misc_gem_pearl_05",
	["Berserk"] = "spell_shadow_unholyfrenzy",
	["Veil of Shadow"] = "spell_shadow_gathershadows",
	["Essence of the Red"] = "spell_fire_lavaspawn",
	["Growing Flames"] = "spell_fire_fire",
	["Brood Affliction: Blue"] = "inv_misc_head_dragon_blue",
	["Brood Affliction: Black"] = "inv_misc_head_dragon_black",
	["Brood Affliction: Green"] = "inv_misc_head_dragon_green",
	["Brood Affliction: Red"] = "inv_misc_head_dragon_01",
	["Brood Affliction: Bronze"] = "inv_misc_head_dragon_bronze",
	["Brood Power: Green"] = "spell_nature_astralrecal",
	["Brood Power: Red"] = "spell_fire_fire",
	["Brood Power: Blue"] = "spell_nature_astralrecal",
	["Burning Adrenaline"] = "inv_gauntlets_03",
	["Suppression Aura"] = "spell_fire_windsofwoe",
	["Flame Breath"] = "spell_fire_fire",
	["Bottle of Poison"] = "spell_nature_corrosivebreath",
	["Shadow of Ebonroc"] = "spell_shadow_gathershadows",
	["Flame Buffet"] = "spell_fire_fireball",
	["Thunderclap"] = "spell_nature_thunderclap",
	["Bonereaver's Edge"] = "spell_shadow_curseofsargeras",
	["Tail Lash"] = "ability_criticalstrike",
	["Dropped Weapon"] = "ability_warrior_disarm",
	["Bellowing Roar"] = "spell_shadow_charm",
	["Greater Polymorph"] = "spell_nature_polymorph",
	["Resistance"] = "inv_potion_16",
	["Restoration"] = "inv_potion_01",
	["Ignite Flesh"] = "spell_fire_fire",
	["Thorium Shield Spike"] = "inv_misc_armorkit_20",
	["Flask of the Titans"] = "inv_potion_62",
	["Corrupted Healing"] = "spell_shadow_charm",
	["Flip Out"] = "ability_rogue_disguise",
	["Inferno Effect"] = "spell_frost_stun",
	["Time Lapse"] = "spell_arcane_portalorgrimmar",
	["Frost Trap Aura"] = "spell_frost_frostnova",
	["Thorium Grenade"] = "inv_misc_bomb_08",
	["Increased Stamina"] = "inv_boots_plate_03",
	["Elixir of the Sages"] = "inv_potion_29",
	["Mana Regeneration"] = "inv_potion_45",
	["Kreeg's Stout Beatdown"] = "inv_drink_05",
	["Distilled Wisdom"] = "inv_potion_97",
	["Mark of Detonation"] = "spell_fire_selfdestruct",
	["Shadow Command"] = "spell_shadow_unholyfrenzy",
	["Burning Wish"] = "spell_shadow_psychicscream",
	["Shadow Protection"] = "spell_shadow_ragingscream",
	["Shadow Protection "] = "spell_shadow_ragingscream",
	["Spirit of Zanza"] = "inv_potion_30",
	["Reactive Fade"] = "spell_magic_lesserinvisibilty",
	["Second Wind"] = "inv_jewelry_talisman_06",
	["Siphon Blessing"] = "spell_shadow_charm",
	["Stratholme Holy Water"] = "inv_potion_75",
	["Zulian Slice"] = "trade_engineering",
	["Shadow Flame"] = "spell_fire_incinerate",
	["Brood Power: Black"] = "spell_fire_fire",
	["Bomb"] = "spell_fire_selfdestruct",
	["Knock Away"] = "inv_gauntlets_05",
	["Strike"] = "ability_rogue_ambush",
	["Wing Buffet"] = "inv_misc_monsterscales_14",
	["Fireball Volley"] = "spell_fire_flamebolt",
	["Shadow Bolt Volley"] = "spell_shadow_shadowbolt",
	["Immolation"] = "spell_shadow_summoninfernal",
	["Exploit Weakness"] = "ability_backstab",
	["Meteor"] = "spell_fire_fireball02",
	["Shadow Storm"] = "spell_shadow_shadowbolt",
	["Plague Effect"] = "spell_shadow_curseoftounges",
	["Explode"] = "spell_fire_sealoffire",
	["Poison Bolt Volley"] = "spell_nature_corrosivebreath",
	["Poison Shock"] = "spell_nature_acid_01",
	["Noxious Poison"] = "spell_nature_corrosivebreath",
	["Toxic Volley"] = "spell_nature_corrosivebreath",
	["Uppercut"] = "inv_gauntlets_05",
	["Unbalancing Strike"] = "ability_warrior_decisivestrike",
	["Trample"] = "spell_nature_natureswrath",
	["Poison Bolt"] = "spell_nature_corrosivebreath",
	["Stinger Charge"] = "ability_warrior_charge",
	["Debilitating Charge"] = "ability_warrior_charge",
	["Acid Spit"] = "spell_nature_corrosivebreath",
	["Pierce Armor"] = "spell_shadow_vampiricaura",
	["Knockback"] = "ability_kick",
	["Toxin"] = "spell_nature_corrosivebreath",
	["Head Butt"] = "inv_gauntlets_05",
	["Toxic Vapors"] = "spell_nature_corrosivebreath",
	["Spell Vulnerability"] = "spell_holy_elunesgrace",
	["Cenarion Favor"] = "spell_nature_rockbiter",
	["Nature Protection"] = "inv_potion_06",
	["Ancestral Fortitude"] = "spell_nature_undyingstrength",
	["Greater Stoneshield"] = "inv_potion_69",
	["Healing Way"] = "Spell_nature_healingway",
	["Mortal Wound"] = "ability_criticalstrike",
	["Entangle"] = "spell_nature_stranglevines",
	["True Fulfillment"] = "spell_shadow_charm",
	["Plague"] = "spell_shadow_shadowbolt",
	["Stunning Blow"] = "spell_holy_dizzy",
	["Ascendance"] = "spell_lightning_lightningbolt01",
	["Arcane Shroud"] = "spell_magic_lesserinvisibilty",
	["Greater Armor"] = "inv_potion_86",
	["Arcane Elixir"] = "inv_potion_30",
	["Greater Firepower"] = "inv_potion_60",
	["Arcane Protection"] = "inv_potion_83",
	["Warchief's Blessing"] = "spell_arcane_teleportorgrimmar",
	["Yaaarrrr"] = "ability_rogue_disguise",
	["Frost Protection"] = "spell_frost_frostarmor02",
	["Nature Protection"] = "inv_potion_06",
	["Shadow Protection"] = "inv_potion_44",
	["Holy Protection"] = "inv_potion_09",
	["Juju Flurry"] = "inv_misc_monsterscales_17",
	["Chromatic Infusion"] = "spell_holy_mindvision",
	["Brittle Armor"] = "spell_shadow_grimward",
	["Zandalarian Hero Medallion"] = "inv_jewelry_necklace_13",
	["Essence of Sapphiron"] = "inv_trinket_naxxramas06",
	["Rogue Armor Energize Effect"] = "trade_engineering",
	["Lava Bomb"] = "spell_fire_selfdestruct",
	["Corrosive Acid"] = "spell_nature_acid_01",
	["Frost Burn"] = "spell_frost_chillingblast",
	["Polymorph: Chicken"] = "spell_magic_polymorphchicken",
	["Polymorph: Cow"] = "spell_nature_polymorph",
	["Polymorph: Sheep"] = "spell_nature_polymorph",
	["Magic Dust"] = "inv_misc_dust_02",
	["Involuntary Transformation"] = "spell_shadow_charm",
	["Cauterizing Flames"] = "spell_fire_volcano",
	["Poisonous Blood"] = "spell_nature_regenerate",
	["Venom Spit"] = "spell_nature_corrosivebreath",
	["Delusions of Jin'do"] = "spell_shadow_unholyfrenzy",
	["Intimidating Roar"] = "ability_golemthunderclap",
	["Poison Cloud"] = "spell_nature_abolishmagic",
	["Hex"] = "spell_shaman_hex",
	["Enveloping Webs"] = "spell_nature_earthbind",
	["Will of Hakkar"] = "spell_shadow_shadowworddominate",
	["Brain Wash"] = "spell_shadow_shadowworddominate",
	["Whirling Trip"] = "inv_spear_05",
	["Threatening Gaze"] = "spell_shadow_charm",
	["Corrupted Blood"] = "spell_shadow_corpseexplode",
	["Cause Insanity"] = "spell_shadow_shadowworddominate",
	["Mark of Arlokk"] = "ability_hunter_snipershot",
	["Corrosive Poison"] = "spell_nature_corrosivebreath",
	["Blood Siphon"] = "spell_shadow_lifedrain",
	["Axe Flurry"] = "inv_axe_06",
	["Sonic Burst"] = "spell_shadow_teleport",
	["Fall down"] = "spell_magic_featherfall",
	["Curse of Blood"] = "spell_shadow_ritualofsacrifice",
	["Shrink"] = "spell_shadow_antishadow",
	["Parasitic Serpent"] = "inv_misc_monsterhead_03",
	["Soul Tap"] = "trade_engineering",
	["Slowing Poison"] = "spell_nature_slowpoison",
	["Web Spin"] = "spell_nature_earthbind",
	["Infected Bite"] = "spell_shadow_callofbone",
	["Tranquilizing Poison"] = "ability_creature_poison_03",
	["Intoxicating Venom"] = "ability_creature_poison_01",
	["Ancient Despair"] = "spell_shadow_mindsteal",
	["Sand Trap"] = "inv_misc_dust_02",
	["Hive'Zara Catalyst"] = "ability_creature_poison_02",
	["Creeping Plague"] = "spell_nature_bloodlust",
	["Sundering Cleave"] = "ability_warrior_sunder",
	["Consume"] = "spell_nature_drowsy",
	["Dreamless Sleep"] = "spell_nature_sleep",
	["Chromatic Mutation"] = "spell_shadow_metamorphosis",
	["Brood Power: Bronze"] = "spell_nature_astralrecal",
	["Brain Damage"] = "ability_gouge",
	["Night Dragon's Breath"] = "trade_engineering",
	["Aura of Command"] = "inv_banner_03",
	["Persistent Shield"] = "inv_misc_ahnqirajtrinket_06",
	["Stormcaller's Wrath"] = "spell_nature_starfall",
	["Swiftmend"] = "inv_relics_idolofrejuvenation",
	["Felstriker"] = "ability_backstab",
	["Fury of Forgewright"] = "spell_fire_incinerate",
	["Primal Blessing"] = "ability_hunter_harass",
	["Spinal Reaper"] = "spell_holy_holybolt",
	["Untamed Fury"] = "spell_nature_bloodlust",
	["The Eye of Diminution"] = "spell_magic_lesserinvisibilty",
	["Kiss of the Spider"] = "inv_trinket_naxxramas04",
	["Glyph of Deflection"] = "inv_trinket_naxxramas05",
	["The Eye of the Dead"] = "inv_trinket_naxxramas01",
	["Slayer's Crest"] = "inv_trinket_naxxramas03",
	["Badge of the Swarmguard"] = "inv_misc_ahnqirajtrinket_04",
	["Jom Gabbar"] = "inv_misc_enggizmos_19",
	["The Burrower's Shell"] = "spell_holy_devotionaura",
	["Thrash"] = "ability_warrior_punishingblow",
	["Invigorate"] = "spell_holy_greaterheal",
	["Head Rush"] = "spell_nature_groundingtotem",
	["Venomous Totem"] = "spell_totem_wardofdraining",
	["Enigma Resist Bonus"] = "inv_helmet_06",
	["Enigma Blizzard Bonus"] = "inv_helmet_06",
	["Adaptive Warding"] = "inv_bracer_13",
	["Not There"] = "temp",
	["Oracle Healing Bonus"] = "inv_shoulder_03",
	["Epiphany"] = "temp",
	["Aegis of Preservation"] = "spell_holy_blessingofprotection",
	["Symbols of Unending Life Finisher Bonus"] = "trade_engineering",
	["Metamorphosis Rune"] = "inv_misc_rune_06",
	["Battlegear of Eternal Justice"] = "spell_holy_righteousnessaura",
	["Blinding Light"] = "spell_holy_searinglight",
	["Nature Aligned"] = "spell_nature_spiritarmor",
	["Vampirism"] = "spell_holy_lesserheal02",
	["Cheat Death"] = "ability_rogue_cheatdeath",
	["Arcane Infused"] = "spell_nature_wispsplode",
	["Decapitate"] = "temp",
	["Gutgore Ripper"] = "spell_shadow_shadowbolt",
	["Chilled"] = "spell_frost_wisp",
	["Glimpse of Madness"] = "spell_shadow_mindsteal",
	["Engulfing Shadows"] = "spell_shadow_lifedrain02",
	["Elemental Vulnerability"] = "temp",
	["Revealed Flaw"] = "ability_warrior_decisivestrike",
	["Totemic Power"] = "temp",
	["Electric Discharge"] = "spell_lightning_lightningbolt01",
	["Stygian Grasp"] = "spell_shadow_blackplague",
	["Living Free Action"] = "inv_potion_07",
	["Devilsaur Fury"] = "ability_hunter_pet_raptor",
	["Windfury Weapon"] = "spell_nature_cyclone",
	["Great Rage"] = "ability_warrior_warcry",
	["Aura of Protection"] = "spell_holy_devotionaura",
	["Damage Absorb"] = "inv_jewelry_talisman_05",
	["Physical Protection"] = "spell_holy_devotionaura",
	["Harm Prevention Belt"] = "spell_holy_powerwordshield",
	["Rage"] = "spell_shadow_unholyfrenzy",
	["Chromatic Protection: Fire"] = "inv_ore_arcanite_01",
	["Chromatic Protection: Frost"] = "inv_ore_arcanite_01",
	["Chromatic Protection: Nature"] = "inv_ore_arcanite_01",
	["Freeze"] = "temp",
	["Shield Charge"] = "ability_warrior_charge",

	-- Original Icons
	["Abolish Disease"] = "Spell_Nature_NullifyDisease",
	["Abolish Poison Effect"] = "Spell_Nature_NullifyPoison_02",
	["Abolish Poison"] = "Spell_Nature_NullifyPoison_02",
	["Activate MG Turret"] = "INV_Weapon_Rifle_10",
	["Adrenaline Rush"] = "Spell_Shadow_ShadowWordDominate",
	["Aftermath"] = "Spell_Fire_Fire",
	["Aggression"] = "Ability_Racial_Avatar",
	["Aimed Shot"] = "INV_Spear_07",
	["Alchemy"] = "Trade_Alchemy",
	["Ambush"] = "Ability_Rogue_Ambush",
	["Amplify Curse"] = "Spell_Shadow_Contagion",
	["Amplify Magic"] = "Spell_Holy_FlashHeal",
	["Ancestral Healing"] = "Spell_Nature_UndyingStrength",
	["Ancestral Knowledge"] = "Spell_Shadow_GrimWard",
	["Ancestral Spirit"] = "Spell_Nature_Regenerate",
	["Anger Management"] = "Spell_Holy_BlessingOfStamina",
	["Anticipation"] = "Spell_Nature_MirrorImage",
	["Aquatic Form"] = "Ability_Druid_AquaticForm",
	["Arcane Brilliance"] = "Spell_Holy_ArcaneIntellect",
	["Arcane Concentration"] = "Spell_Shadow_ManaBurn",
	["Arcane Explosion"] = "Spell_Nature_WispSplode",
	["Arcane Focus"] = "Spell_Holy_Devotion",
	["Arcane Instability"] = "Spell_Shadow_Teleport",
	["Arcane Intellect"] = "Spell_Holy_MagicalSentry",
	["Arcane Meditation"] = "Spell_Shadow_SiphonMana",
	["Arcane Mind"] = "Spell_Shadow_Charm",
	["Arcane Missiles"] = "Spell_Nature_StarFall",
	["Arcane Power"] = "Spell_Nature_Lightning",
	["Arcane Resistance"] = "Spell_Nature_StarFall",
	["Arcane Shot"] = "Ability_ImpalingBolt",
	["Arcane Subtlety"] = "Spell_Holy_DispelMagic",
	["Arctic Reach"] = "Spell_Shadow_DarkRitual",
	["Aspect of the Beast"] = "Ability_Mount_PinkTiger",
	["Aspect of the Cheetah"] = "Ability_Mount_JungleTiger",
	["Aspect of the Hawk"] = "Spell_Nature_RavenForm",
	["Aspect of the Monkey"] = "Ability_Hunter_AspectOfTheMonkey",
	["Aspect of the Pack"] = "Ability_Mount_WhiteTiger",
	["Aspect of the Wild"] = "Spell_Nature_ProtectionformNature",
	["Astral Recall"] = "Spell_Nature_AstralRecal",
	["Attack"] = "Temp",
	["Attacking"] = "Temp",
	["Auto Shot"] = "Ability_Whirlwind",
	["Axe Specialization"] = "INV_Axe_06",
	["Backstab"] = "Ability_BackStab",
	["Bane"] = "Spell_Shadow_DeathPact",
	["Banish"] = "Spell_Shadow_Cripple",
	["Barkskin Effect"] = "Spell_Nature_StoneClawTotem",
	["Barkskin"] = "Spell_Nature_StoneClawTotem",
	["Barrage"] = "Ability_UpgradeMoonGlaive",
	["Bash"] = "Ability_Druid_Bash",
	["Basic Campfire"] = "Spell_Fire_Fire",
	["Battle Shout"] = "Ability_Warrior_BattleShout",
	["Battle Stance Passive"] = "Ability_Warrior_OffensiveStance",
	["Battle Stance"] = "Ability_Warrior_OffensiveStance",
	["Bear Form"] = "Ability_Racial_BearForm",
	["Beast Lore"] = "Ability_Physical_Taunt",
	["Beast Slaying"] = "INV_Misc_Pelt_Bear_Ruin_02",
	["Beast Training"] = "Ability_Hunter_BeastCall02",
	["Benediction"] = "Spell_Frost_WindWalkOn",
	["Berserker Rage"] = "Spell_Nature_AncestralGuardian",
	["Berserker Stance Passive"] = "Ability_Racial_Avatar",
	["Berserker Stance"] = "Ability_Racial_Avatar",
	["Berserking"] = "Racial_Troll_Berserk",
	["Bestial Discipline"] = "Spell_Nature_AbolishMagic",
	["Bestial Swiftness"] = "Ability_Druid_Dash",
	["Bestial Wrath"] = "Ability_Druid_FerociousBite",
	["Bite"] = "Ability_Racial_Cannibalize",
	["Black Arrow"] = "Ability_TheBlackArrow",
	["Blackout"] = "Spell_Shadow_GatherShadows",
	["Blacksmithing"] = "Trade_BlackSmithing",
	["Blade Flurry"] = "Ability_Warrior_PunishingBlow",
	["Blast Wave"] = "Spell_Holy_Excorcism_02",
	["Blessed Recovery"] = "Spell_Holy_BlessedRecovery",
	["Blessing of Freedom"] = "Spell_Holy_SealOfValor",
	["Blessing of Kings"] = "Spell_Magic_MageArmor",
	["Blessing of Light"] = "Spell_Holy_PrayerOfHealing02",
	["Blessing of Might"] = "Spell_Holy_FistOfJustice",
	["Blessing of Protection"] = "Spell_Holy_SealOfProtection",
	["Blessing of Sacrifice"] = "Spell_Holy_SealOfSacrifice",
	["Blessing of Salvation"] = "Spell_Holy_SealOfSalvation",
	["Blessing of Sanctuary"] = "Spell_Nature_LightningShield",
	["Blessing of Wisdom"] = "Spell_Holy_SealOfWisdom",
	["Blind"] = "Spell_Shadow_MindSteal",
	["Blinding Powder"] = "INV_Misc_Ammo_Gunpowder_02",
	["Blink"] = "Spell_Arcane_Blink",
	["Blizzard"] = "Spell_Frost_IceStorm",
	["Block"] = "Ability_Defend",
	["Blood Craze"] = "Spell_Shadow_SummonImp",
	["Blood Frenzy"] = "Ability_GhoulFrenzy",
	["Blood Fury"] = "Racial_Orc_BerserkerStrength",
	["Blood Pact"] = "Spell_Shadow_BloodBoil",
	["Bloodrage"] = "Ability_Racial_BloodRage",
	["Bloodthirst"] = "Spell_Nature_BloodLust",
	["Booming Voice"] = "Spell_Nature_Purge",
	["Bow Specialization"] = "INV_Weapon_Bow_12",
	["Bows"] = "INV_Weapon_Bow_05",
	["Bright Campfire"] = "Spell_Fire_Fire",
	["Brutal Impact"] = "Ability_Druid_Bash",
	["Burning Soul"] = "Spell_Fire_Fire",
	["Call Pet"] = "Ability_Hunter_BeastCall",
	["Call of Flame"] = "Spell_Fire_Immolation",
	["Call of Thunder"] = "Spell_Nature_CallStorm",
	["Camouflage"] = "Ability_Stealth",
	["Cannibalize"] = "Ability_Racial_Cannibalize",
	["Cat Form"] = "Ability_Druid_CatForm",
	["Cataclysm"] = "Spell_Fire_WindsofWoe",
	["Chain Heal"] = "Spell_Nature_HealingWaveGreater",
	["Chain Lightning"] = "Spell_Nature_ChainLightning",
	["Challenging Roar"] = "Ability_Druid_ChallangingRoar",
	["Challenging Shout"] = "Ability_BullRush",
	["Charge Rage Bonus Effect"] = "Ability_Warrior_Charge",
	["Charge"] = "Ability_Warrior_Charge",
	["Charge Stun"] = "Ability_Warrior_Charge",
	["Cheap Shot"] = "Ability_CheapShot",
	["Chilled"] = "Spell_Frost_IceStorm",
	["Claw"] = "Ability_Druid_Rake",
	["Cleanse"] = "Spell_Holy_Renew",
	["Clearcasting"] = "Spell_Shadow_ManaBurn",
	["Cleave"] = "Ability_Warrior_Cleave",
	["Clever Traps"] = "Spell_Nature_TimeStop",
	["Closing"] = "Temp",
	["Cloth"] = "INV_Chest_Cloth_21",
	["Cobra Reflexes"] = "Spell_Nature_GuardianWard",
	["Cold Blood"] = "Spell_Ice_Lament",
	["Cold Snap"] = "Spell_Frost_WizardMark",
	["Combat Endurance"] = "Spell_Nature_AncestralGuardian",
	["Combustion"] = "Spell_Fire_SealOfFire",
	["Command"] = "Ability_Warrior_WarCry",
	["Concentration Aura"] = "Spell_Holy_MindSooth",
	["Concussion Blow"] = "Ability_ThunderBolt",
	["Concussion"] = "Spell_Fire_Fireball",
	["Concussive Shot"] = "Spell_Frost_Stun",
	["Cone of Cold"] = "Spell_Frost_Glacier",
	["Conflagrate"] = "Spell_Fire_Fireball",
	["Conjure Food"] = "INV_Misc_Food_10",
	["Conjure Mana Agate"] = "INV_Misc_Gem_Emerald_01",
	["Conjure Mana Citrine"] = "INV_Misc_Gem_Opal_01",
	["Conjure Mana Jade"] = "INV_Misc_Gem_Emerald_02",
	["Conjure Mana Ruby"] = "INV_Misc_Gem_Ruby_01",
	["Conjure Water"] = "INV_Drink_06",
	["Consecration"] = "Spell_Holy_InnerFire",
	["Consume Shadows"] = "Spell_Shadow_AntiShadow",
	["Convection"] = "Spell_Nature_WispSplode",
	["Conviction"] = "Spell_Holy_RetributionAura",
	["Cooking"] = "INV_Misc_Food_15",
	["Corruption"] = "Spell_Shadow_AbominationExplosion",
	["Counterattack"] = "Ability_Warrior_Challange",
	["Counterspell"] = "Spell_Frost_IceShock",
	["Cower"] = "Ability_Druid_Cower",
	["Create Firestone (Lesser)"]="INV_Ammo_FireTar",
	["Create Firestone"]="INV_Ammo_FireTar",
	["Create Firestone (Greater)"]="INV_Ammo_FireTar",
	["Create Firestone (Major)"]="INV_Ammo_FireTar",
	["Create Healthstone (Minor)"]="INV_Stone_04",
	["Create Healthstone (Lesser)"]="INV_Stone_04",
	["Create Healthstone"]="INV_Stone_04",
	["Create Healthstone (Greater)"]="INV_Stone_04",
	["Create Healthstone (Major)"]="INV_Stone_04",
	["Create Soulstone (Minor)"]="Spell_Shadow_SoulGem",
	["Create Soulstone (Lesser)"]="Spell_Shadow_SoulGem",
	["Create Soulstone"]="Spell_Shadow_SoulGem",
	["Create Soulstone (Greater)"]="Spell_Shadow_SoulGem",
	["Create Soulstone (Major)"]="Spell_Shadow_SoulGem",
	["Create Spellstone"]="INV_Misc_Gem_Sapphire_01",
	["Create Spellstone (Greater)"]="INV_Misc_Gem_Sapphire_01",
	["Create Spellstone (Major)"]="INV_Misc_Gem_Sapphire_01",
	["Crippling Poison II"] = "Ability_PoisonSting",
	["Crippling Poison"] = "Ability_PoisonSting",
	["Critical Mass"] = "Spell_Nature_WispHeal",
	["Crossbows"] = "INV_Weapon_Crossbow_01",
	["Cruelty"] = "Ability_Rogue_Eviscerate",
	["Cultivation"] = "INV_Misc_Flower_01",
	["Cure Disease"] = "Spell_Holy_NullifyDisease",
	["Cure Poison"] = "Spell_Nature_NullifyPoison",
	["Curse of Agony"] = "Spell_Shadow_CurseOfSargeras",
	["Curse of Doom Effect"] = "Spell_Shadow_AuraOfDarkness",
	["Curse of Doom"] = "Spell_Shadow_AuraOfDarkness",
	["Curse of Exhaustion"] = "Spell_Shadow_GrimWard",
	["Curse of Idiocy"] = "Spell_Shadow_MindRot",
	["Curse of Recklessness"] = "Spell_Shadow_UnholyStrength",
	["Curse of Shadow"] = "Spell_Shadow_CurseOfAchimonde",
	["Curse of Tongues"] = "Spell_Shadow_CurseOfTounges",
	["Curse of Weakness"] = "Spell_Shadow_CurseOfMannoroth",
	["Curse of the Elements"] = "Spell_Shadow_ChillTouch",
	["Dagger Specialization"] = "INV_Weapon_ShortBlade_05",
	["Daggers"] = "Ability_SteelMelee",
	["Dampen Magic"] = "Spell_Nature_AbolishMagic",
	["Dark Pact"] = "Spell_Shadow_DarkRitual",
	["Darkness"] = "Spell_Shadow_Twilight",
	["Dash"] = "Ability_Druid_Dash",
	["Deadly Poison II"] = "Ability_Rogue_DualWeild",
	["Deadly Poison III"] = "Ability_Rogue_DualWeild",
	["Deadly Poison IV"] = "Ability_Rogue_DualWeild",
	["Deadly Poison V"] = "Ability_Rogue_DualWeild",
	["Deadly Poison"] = "Ability_Rogue_DualWeild",
	["Death Coil"] = "Spell_Shadow_DeathCoil",
	["Death Wish"] = "Spell_Shadow_DeathPact",
	["Deep Wound"] = "Ability_BackStab",
	["Defense"] = "Ability_Racial_ShadowMeld",
	["Defensive Stance Passive"] = "Ability_Warrior_DefensiveStance",
	["Defensive Stance"] = "Ability_Warrior_DefensiveStance",
	["Defensive State 2"] = "Ability_Defend",
	["Defensive State"] = "Ability_Defend",
	["Defiance"] = "Ability_Warrior_InnerRage",
	["Deflection"] = "Ability_Parry",
	["Demon Armor"] = "Spell_Shadow_RagingScream",
	["Demon Skin"] = "Spell_Shadow_RagingScream",
	["Demonic Embrace"] = "Spell_Shadow_Metamorphosis",
	["Demonic Sacrifice"] = "Spell_Shadow_PsychicScream",
	["Demoralizing Roar"] = "Ability_Druid_DemoralizingRoar",
	["Demoralizing Shout"] = "Ability_Warrior_WarCry",
	["Desperate Prayer"] = "Spell_Holy_Restoration",
	["Destructive Reach"] = "Spell_Shadow_CorpseExplode",
	["Detect Greater Invisibility"] = "Spell_Shadow_DetectInvisibility",
	["Detect Invisibility"] = "Spell_Shadow_DetectInvisibility",
	["Detect Lesser Invisibility"] = "Spell_Shadow_DetectLesserInvisibility",
	["Detect Magic"] = "Spell_Holy_Dizzy",
	["Detect Traps"] = "Ability_Spy",
	["Detect"] = "Ability_Hibernation",
	["Deterrence"] = "Ability_Whirlwind",
	["Devastation"] = "Spell_Fire_FlameShock",
	["Devotion Aura"] = "Spell_Holy_DevotionAura",
	["Devour Magic Effect"] = "Spell_Nature_Purge",
	["Devour Magic"] = "Spell_Nature_Purge",
	["Devouring Plague"] = "Spell_Shadow_BlackPlague",
	["Diplomacy"] = "INV_Misc_Note_02",
	["Dire Bear Form"] = "Ability_Racial_BearForm",
	["Disarm Trap"] = "Spell_Shadow_GrimWard",
	["Disarm"] = "Ability_Warrior_Disarm",
	["Disease Cleansing Totem"] = "Spell_Nature_DiseaseCleansingTotem",
	["Disenchant"] = "Spell_Holy_RemoveCurse",
	["Disengage"] = "Ability_Rogue_Feint",
	["Dismiss Pet"] = "Spell_Nature_SpiritWolf",
	["Dispel Magic"] = "Spell_Holy_DispelMagic",
	["Distract"] = "Ability_Rogue_Distract",
	["Distracting Shot"] = "Spell_Arcane_Blink",
	["Dive"] = "Spell_Shadow_BurningSpirit",
	["Divine Favor"] = "Spell_Holy_Heal",
	["Divine Fury"] = "Spell_Holy_SealOfWrath",
	["Divine Intellect"] = "Spell_Nature_Sleep",
	["Divine Intervention"] = "Spell_Nature_TimeStop",
	["Divine Protection"] = "Spell_Holy_Restoration",
	["Divine Shield"] = "Spell_Holy_DivineIntervention",
	["Divine Spirit"] = "Spell_Holy_DivineSpirit",
	["Divine Strength"] = "Ability_GolemThunderClap",
	["Dodge"] = "Spell_Nature_Invisibilty",
	["Drain Life"] = "Spell_Shadow_LifeDrain02",
	["Drain Mana"] = "Spell_Shadow_SiphonMana",
	["Drain Soul"] = "Spell_Shadow_Haunting",
	["Dual Wield Specialization"] = "Ability_DualWield",
	["Dual Wield"] = "Ability_DualWield",
	["Duel"] = "Temp",
	["Eagle Eye"] = "Ability_Hunter_EagleEye",
	["Earth Shock"] = "Spell_Nature_EarthShock",
	["Earthbind Totem"] = "Spell_Nature_StrengthOfEarthTotem02",
	["Efficiency"] = "Spell_Frost_WizardMark",
	["Elemental Focus"] = "Spell_Shadow_ManaBurn",
	["Elemental Fury"] = "Spell_Fire_Volcano",
	["Elemental Mastery"] = "Spell_Nature_WispHeal",
	["Elune's Grace"] = "Spell_Holy_ElunesGrace",
	["Elusiveness"] = "Spell_Magic_LesserInvisibilty",
	["Emberstorm"] = "Spell_Fire_SelfDestruct",
	["Enchanting"] = "Trade_Engraving",
	["Endurance Training"] = "Spell_Nature_Reincarnation",
	["Endurance"] = "Spell_Nature_UnyeildingStamina",
	["Engineering Specialization"] = "INV_Misc_Gear_01",
	["Engineering"] = "Trade_Engineering",
	["Enrage"] = "Ability_Druid_Enrage",
	["Enslave Demon"] = "Spell_Shadow_EnslaveDemon",
	["Entangling Roots"] = "Spell_Nature_StrangleVines",
	["Entrapment"] = "Spell_Nature_StrangleVines",
	["Escape Artist"] = "Ability_Rogue_Trip",
	["Evasion"] = "Spell_Shadow_ShadowWard",
	["Eventide"] = "Spell_Frost_Stun",
	["Eviscerate"] = "Ability_Rogue_Eviscerate",
	["Evocation"] = "Spell_Nature_Purge",
	["Execute"] = "INV_Sword_48",
	["Exorcism"] = "Spell_Holy_Excorcism_02",
	["Expansive Mind"] = "INV_Enchant_EssenceEternalLarge",
	["Explosive Trap Effect"] = "Spell_Fire_SelfDestruct",
	["Explosive Trap"] = "Spell_Fire_SelfDestruct",
	["Expose Armor"] = "Ability_Warrior_Riposte",
	["Eye for an Eye"] = "Spell_Holy_EyeforanEye",
	["Eye of Kilrogg"] = "Spell_Shadow_EvilEye",
	["Eyes of the Beast"] = "Ability_EyeOfTheOwl",
	["Fade"] = "Spell_Magic_LesserInvisibilty",
	["Faerie Fire"] = "Spell_Nature_FaerieFire",
	["Far Sight"] = "Spell_Nature_FarSight",
	["Fear Ward"] = "Spell_Holy_Excorcism",
	["Fear"] = "Spell_Shadow_Possession",
	["Feed Pet"] = "Ability_Hunter_BeastTraining",
	["Feedback"] = "Spell_Shadow_RitualOfSacrifice",
	["Feign Death"] = "Ability_Rogue_FeignDeath",
	["Feint"] = "Ability_Rogue_Feint",
	["Fel Concentration"] = "Spell_Shadow_FingerOfDeath",
	["Fel Domination"] = "Spell_Nature_RemoveCurse",
	["Fel Intellect"] = "Spell_Holy_MagicalSentry",
	["Fel Stamina"] = "Spell_Shadow_AntiShadow",
	["Felfire"] = "Spell_Fire_Fireball",
	["Feline Grace"] = "INV_Feather_01",
	["Feline Swiftness"] = "Spell_Nature_SpiritWolf",
	["Feral Aggression"] = "Ability_Druid_DemoralizingRoar",
	["Feral Charge"] = "Ability_Hunter_Pet_Bear",
	["Feral Instinct"] = "Ability_Ambush",
	["Ferocious Bite"] = "Ability_Druid_FerociousBite",
	["Ferocity"] = "INV_Misc_MonsterClaw_04",
	["Fetish"] = "INV_Misc_Horn_01",
	["Find Herbs"] = "INV_Misc_Flower_02",
	["Find Minerals"] = "Spell_Nature_Earthquake",
	["Find Treasure"] = "Racial_Dwarf_FindTreasure",
	["Fire Blast"] = "Spell_Fire_Fireball",
	["Fire Nova Totem"] = "Spell_Fire_SealOfFire",
	["Fire Power"] = "Spell_Fire_Immolation",
	["Fire Resistance Aura"] = "Spell_Fire_SealOfFire",
	["Fire Resistance Totem"] = "Spell_FireResistanceTotem_01",
	["Fire Resistance"] = "Spell_Fire_FireArmor",
	["Fire Shield"] = "Spell_Fire_FireArmor",
	["Fire Vulnerability"] = "Spell_Fire_SoulBurn",
	["Fire Ward"] = "Spell_Fire_FireArmor",
	["Fireball"] = "Spell_Fire_FlameBolt",
	["Firebolt"] = "Spell_Fire_FireBolt",
	["First Aid"] = "Spell_Holy_SealOfSacrifice",
	["Fishing Poles"] = "Trade_Fishing",
	["Fishing"] = "Trade_Fishing",
	["Fist Weapon Specialization"] = "INV_Gauntlets_04",
	["Fist Weapons"] = "INV_Gauntlets_04",
	["Flame Shock"] = "Spell_Fire_FlameShock",
	["Flame Throwing"] = "Spell_Fire_Flare",
	["Flamestrike"] = "Spell_Fire_SelfDestruct",
	["Flamethrower"] = "Spell_Fire_Incinerate",
	["Flametongue Totem"] = "Spell_Nature_GuardianWard",
	["Flametongue Weapon"] = "Spell_Fire_FlameTounge",
	["Flare"] = "Spell_Fire_Flare",
	["Flash Heal"] = "Spell_Holy_FlashHeal",
	["Flash of Light"] = "Spell_Holy_FlashHeal",
	["Flurry"] = "Ability_GhoulFrenzy",
	["Focused Casting"] = "Spell_Arcane_Blink",
	["Force of Will"] = "Spell_Nature_SlowingTotem",
	["Freezing Trap"] = "Spell_Frost_ChainsOfIce",
	["Frenzied Regeneration"] = "Ability_BullRush",
	["Frenzy"] = "INV_Misc_MonsterClaw_03",
	["Frost Armor"] = "Spell_Frost_FrostArmor02",
	["Frost Channeling"] = "Spell_Frost_Stun",
	["Frost Nova"] = "Spell_Frost_FrostNova",
	["Frost Resistance Aura"] = "Spell_Frost_WizardMark",
	["Frost Resistance Totem"] = "Spell_FrostResistanceTotem_01",
	["Frost Resistance"] = "Spell_Frost_FrostWard",
	["Frost Shock"] = "Spell_Frost_FrostShock",
	["Frost Trap"] = "Spell_Frost_FreezingBreath",
	["Frost Ward"] = "Spell_Frost_FrostWard",
	["Frostbite"] = "Spell_Frost_FrostArmor",
	["Frostbolt"] = "Spell_Frost_FrostBolt02",
	["Frostbrand Weapon"] = "Spell_Frost_FrostBrand",
	["Furious Howl"] = "Ability_Hunter_Pet_Wolf",
	["Furor"] = "Spell_Holy_BlessingOfStamina",
	["Garrote"] = "Ability_Rogue_Garrote",
	["Generic"] = "INV_Shield_09",
	["Ghost Wolf"] = "Spell_Nature_SpiritWolf",
	["Ghostly Strike"] = "Spell_Shadow_Curse",
	["Gift of Nature"] = "Spell_Nature_ProtectionformNature",
	["Gift of the Wild"] = "Spell_Nature_Regeneration",
	["Gouge"] = "Ability_Gouge",
	["Grace of Air Totem"] = "Spell_Nature_InvisibilityTotem",
	["Great Stamina"] = "Spell_Nature_UnyeildingStamina",
	["Greater Blessing of Kings"] = "Spell_Magic_GreaterBlessingofKings",
	["Greater Blessing of Light"] = "Spell_Holy_GreaterBlessingofLight",
	["Greater Blessing of Might"] = "Spell_Holy_GreaterBlessingofKings",
	["Greater Blessing of Salvation"] = "Spell_Holy_GreaterBlessingofSalvation",
	["Greater Blessing of Sanctuary"] = "Spell_Holy_GreaterBlessingofSanctuary",
	["Greater Blessing of Wisdom"] = "Spell_Holy_GreaterBlessingofWisdom",
	["Greater Heal"] = "Spell_Holy_GreaterHeal",
	["Grim Reach"] = "Spell_Shadow_CallofBone",
	["Grounding Totem"] = "Spell_Nature_GroundingTotem",
	["Grovel"] = "Temp",
	["Growl"] = "Ability_Physical_Taunt",
	["Guardian's Favor"] = "Spell_Holy_SealOfProtection",
	["Gun Specialization"] = "INV_Musket_03",
	["Guns"] = "INV_Weapon_Rifle_01",
	["Hammer of Justice"] = "Spell_Holy_SealOfMight",
	["Hammer of Wrath"] = "Ability_ThunderClap",
	["Hamstring"] = "Ability_ShockWave",
	["Harass"] = "Ability_Hunter_Harass",
	["Hardiness"] = "INV_Helmet_23",
	["Hawk Eye"] = "Ability_TownWatch",
	["Heal"] = "Spell_Holy_Heal",
	["Healing Focus"] = "Spell_Holy_HealingFocus",
	["Healing Light"] = "Spell_Holy_HolyBolt",
	["Healing Stream Totem"] = "INV_Spear_04",
	["Healing Touch"] = "Spell_Nature_HealingTouch",
	["Healing Wave"] = "Spell_Nature_MagicImmunity",
	["Health Funnel"] = "Spell_Shadow_LifeDrain",
	["Heart of the Wild"] = "Spell_Holy_BlessingOfAgility",
	["Hellfire Effect"] = "Spell_Fire_Incinerate",
	["Hellfire"] = "Spell_Fire_Incinerate",
	["Hemorrhage"] = "Spell_Shadow_LifeDrain",
	["Herbalism"] = "Spell_Nature_NatureTouchGrow",
	["Heroic Strike"] = "Ability_Rogue_Ambush",
	["Hex of Weakness"] = "Spell_Shadow_FingerOfDeath",
	["Hibernate"] = "Spell_Nature_Sleep",
	["Holy Fire"] = "Spell_Holy_SearingLight",
	["Holy Light"] = "Spell_Holy_HolyBolt",
	["Holy Nova"] = "Spell_Holy_HolyNova",
	["Holy Power"] = "Spell_Holy_Power",
	["Holy Reach"] = "Spell_Holy_Purify",
	["Holy Shield"] = "Spell_Holy_BlessingOfProtection",
	["Holy Shock"] = "Spell_Holy_SearingLight",
	["Holy Specialization"] = "Spell_Holy_SealOfSalvation",
	["Holy Wrath"] = "Spell_Holy_Excorcism",
	["Honorless Target"] = "Spell_Magic_LesserInvisibilty",
	["Horse Riding"] = "Spell_Nature_Swiftness",
	["Howl of Terror"] = "Spell_Shadow_DeathScream",
	["Humanoid Slaying"] = "Spell_Holy_PrayerOfHealing",
	["Hunter's Mark"] = "Ability_Hunter_SniperShot",
	["Hurricane"] = "Spell_Nature_Cyclone",
	["Ice Armor"] = "Spell_Frost_FrostArmor02",
	["Ice Barrier"] = "Spell_Ice_Lament",
	["Ice Block"] = "Spell_Frost_Frost",
	["Ice Shards"] = "Spell_Frost_IceShard",
	["Ignite"] = "Spell_Fire_Incinerate",
	["Illumination"] = "Spell_Holy_GreaterHeal",
	["Immolate"] = "Spell_Fire_Immolation",
	["Immolation Trap Effect"] = "Spell_Fire_FlameShock",
	["Immolation Trap"] = "Spell_Fire_FlameShock",
	["Impact"] = "Spell_Fire_MeteorStorm",
	["Impale"] = "Ability_SearingArrow",
	["Improved Ambush"] = "Ability_Rogue_Ambush",
	["Improved Arcane Explosion"] = "Spell_Nature_WispSplode",
	["Improved Arcane Missiles"] = "Spell_Nature_StarFall",
	["Improved Arcane Shot"] = "Ability_ImpalingBolt",
	["Improved Aspect of the Hawk"] = "Spell_Nature_RavenForm",
	["Improved Aspect of the Monkey"] = "Ability_Hunter_AspectOfTheMonkey",
	["Improved Backstab"] = "Ability_BackStab",
	["Improved Battle Shout"] = "Ability_Warrior_BattleShout",
	["Improved Berserker Rage"] = "Spell_Nature_AncestralGuardian",
	["Improved Blessing of Might"] = "Spell_Holy_FistOfJustice",
	["Improved Blessing of Wisdom"] = "Spell_Holy_SealOfWisdom",
	["Improved Blizzard"] = "Spell_Frost_IceStorm",
	["Improved Bloodrage"] = "Ability_Racial_BloodRage",
	["Improved Chain Heal"] = "Spell_Nature_HealingWaveGreater",
	["Improved Chain Lightning"] = "Spell_Nature_ChainLightning",
	["Improved Challenging Shout"] = "Ability_Warrior_Challange",
	["Improved Charge"] = "Ability_Warrior_Charge",
	["Improved Cheap Shot"] = "Ability_CheapShot",
	["Improved Cleave"] = "Ability_Warrior_Cleave",
	["Improved Concentration Aura"] = "Spell_Holy_MindSooth",
	["Improved Concussive Shot"] = "Spell_Frost_Stun",
	["Improved Cone of Cold"] = "Spell_Frost_Glacier",
	["Improved Corruption"] = "Spell_Shadow_AbominationExplosion",
	["Improved Counterspell"] = "Spell_Frost_IceShock",
	["Improved Curse of Agony"] = "Spell_Shadow_CurseOfSargeras",
	["Improved Curse of Exhaustion"] = "Spell_Shadow_GrimWard",
	["Improved Curse of Weakness"] = "Spell_Shadow_CurseOfMannoroth",
	["Improved Dampen Magic"] = "Spell_Nature_AbolishMagic",
	["Improved Deadly Poison"] = "Ability_Rogue_DualWeild",
	["Improved Demoralizing Shout"] = "Ability_Warrior_WarCry",
	["Improved Devotion Aura"] = "Spell_Holy_DevotionAura",
	["Improved Disarm"] = "Ability_Warrior_Disarm",
	["Improved Distract"] = "Ability_Rogue_Distract",
	["Improved Drain Life"] = "Spell_Shadow_LifeDrain02",
	["Improved Drain Mana"] = "Spell_Shadow_SiphonMana",
	["Improved Drain Soul"] = "Spell_Shadow_Haunting",
	["Improved Enrage"] = "Ability_Druid_Enrage",
	["Improved Enslave Demon"] = "Spell_Shadow_EnslaveDemon",
	["Improved Entangling Roots"] = "Spell_Nature_StrangleVines",
	["Improved Evasion"] = "Spell_Shadow_ShadowWard",
	["Improved Eviscerate"] = "Ability_Rogue_Eviscerate",
	["Improved Execute"] = "INV_Sword_48",
	["Improved Expose Armor"] = "Ability_Warrior_Riposte",
	["Improved Eyes of the Beast"] = "Ability_EyeOfTheOwl",
	["Improved Fade"] = "Spell_Magic_LesserInvisibilty",
	["Improved Feign Death"] = "Ability_Rogue_FeignDeath",
	["Improved Fire Blast"] = "Spell_Fire_Fireball",
	["Improved Fire Nova Totem"] = "Spell_Fire_SealOfFire",
	["Improved Fire Ward"] = "Spell_Fire_FireArmor",
	["Improved Fireball"] = "Spell_Fire_FlameBolt",
	["Improved Firebolt"] = "Spell_Fire_FireBolt",
	["Improved Firestone"] = "INV_Ammo_FireTar",
	["Improved Flamestrike"] = "Spell_Fire_SelfDestruct",
	["Improved Flametongue Weapon"] = "Spell_Fire_FlameTounge",
	["Improved Flash of Light"] = "Spell_Holy_FlashHeal",
	["Improved Frost Nova"] = "Spell_Frost_FreezingBreath",
	["Improved Frost Ward"] = "Spell_Frost_FrostWard",
	["Improved Frostbolt"] = "Spell_Frost_FrostBolt02",
	["Improved Frostbrand Weapon"] = "Spell_Frost_FrostBrand",
	["Improved Garrote"] = "Ability_Rogue_Garrote",
	["Improved Ghost Wolf"] = "Spell_Nature_SpiritWolf",
	["Improved Gouge"] = "Ability_Gouge",
	["Improved Grace of Air Totem"] = "Spell_Nature_InvisibilityTotem",
	["Improved Grounding Totem"] = "Spell_Nature_GroundingTotem",
	["Improved Hammer of Justice"] = "Spell_Holy_SealOfMight",
	["Improved Hamstring"] = "Ability_ShockWave",
	["Improved Healing Stream Totem"] = "INV_Spear_04",
	["Improved Healing Touch"] = "Spell_Nature_HealingTouch",
	["Improved Healing Wave"] = "Spell_Nature_MagicImmunity",
	["Improved Healing"] = "Spell_Holy_Heal02",
	["Improved Health Funnel"] = "Spell_Shadow_LifeDrain",
	["Improved Healthstone"] = "INV_Stone_04",
	["Improved Heroic Strike"] = "Ability_Rogue_Ambush",
	["Improved Hunter's Mark"] = "Ability_Hunter_SniperShot",
	["Improved Immolate"] = "Spell_Fire_Immolation",
	["Improved Imp"] = "Spell_Shadow_SummonImp",
	["Improved Inner Fire"] = "Spell_Holy_InnerFire",
	["Improved Instant Poison"] = "Ability_Poisons",
	["Improved Intercept"] = "Ability_Rogue_Sprint",
	["Improved Intimidating Shout"] = "Ability_GolemThunderClap",
	["Improved Judgement"] = "Spell_Holy_RighteousFury",
	["Improved Kick"] = "Ability_Kick",
	["Improved Kidney Shot"] = "Ability_Rogue_KidneyShot",
	["Improved Lash of Pain"] = "Spell_Shadow_Curse",
	["Improved Lay on Hands"] = "Spell_Holy_LayOnHands",
	["Improved Lesser Healing Wave"] = "Spell_Nature_HealingWaveLesser",
	["Improved Life Tap"] = "Spell_Shadow_BurningSpirit",
	["Improved Lightning Bolt"] = "Spell_Nature_Lightning",
	["Improved Lightning Shield"] = "Spell_Nature_LightningShield",
	["Improved Magma Totem"] = "Spell_Fire_SelfDestruct",
	["Improved Mana Burn"] = "Spell_Shadow_ManaBurn",
	["Improved Mana Shield"] = "Spell_Shadow_DetectLesserInvisibility",
	["Improved Mana Spring Totem"] = "Spell_Nature_ManaRegenTotem",
	["Improved Mark of the Wild"] = "Spell_Nature_Regeneration",
	["Improved Mend Pet"] = "Ability_Hunter_MendPet",
	["Improved Mind Blast"] = "Spell_Shadow_UnholyFrenzy",
	["Improved Moonfire"] = "Spell_Nature_StarFall",
	["Improved Nature's Grasp"] = "Spell_Nature_NaturesWrath",
	["Improved Overpower"] = "INV_Sword_05",
	["Improved Power Word: Fortitude"] = "Spell_Holy_WordFortitude",
	["Improved Power Word: Shield"] = "Spell_Holy_PowerWordShield",
	["Improved Prayer of Healing"] = "Spell_Holy_PrayerOfHealing02",
	["Improved Psychic Scream"] = "Spell_Shadow_PsychicScream",
	["Improved Pummel"] = "INV_Gauntlets_04",
	["Improved Regrowth"] = "Spell_Nature_ResistNature",
	["Improved Reincarnation"] = "Spell_Nature_Reincarnation",
	["Improved Rejuvenation"] = "Spell_Nature_Rejuvenation",
	["Improved Rend"] = "Ability_Gouge",
	["Improved Renew"] = "Spell_Holy_Renew",
	["Improved Retribution Aura"] = "Spell_Holy_AuraOfLight",
	["Improved Revenge"] = "Ability_Warrior_Revenge",
	["Improved Revive Pet"] = "Ability_Hunter_BeastSoothe",
	["Improved Righteous Fury"] = "Spell_Holy_SealOfFury",
	["Improved Rockbiter Weapon"] = "Spell_Nature_RockBiter",
	["Improved Rupture"] = "Ability_Rogue_Rupture",
	["Improved Sap"] = "Ability_Sap",
	["Improved Scorch"] = "Spell_Fire_SoulBurn",
	["Improved Scorpid Sting"] = "Ability_Hunter_CriticalShot",
	["Improved Seal of Righteousness"] = "Ability_ThunderBolt",
	["Improved Seal of the Crusader"] = "Spell_Holy_HolySmite",
	["Improved Searing Pain"] = "Spell_Fire_SoulBurn",
	["Improved Searing Totem"] = "Spell_Fire_SearingTotem",
	["Improved Serpent Sting"] = "Ability_Hunter_Quickshot",
	["Improved Shadow Bolt"] = "Spell_Shadow_ShadowBolt",
	["Improved Shadow Word: Pain"] = "Spell_Shadow_ShadowWordPain",
	["Improved Shield Bash"] = "Ability_Warrior_ShieldBash",
	["Improved Shield Block"] = "Ability_Defend",
	["Improved Shield Wall"] = "Ability_Warrior_ShieldWall",
	["Improved Shred"] = "Spell_Shadow_VampiricAura",
	["Improved Sinister Strike"] = "Spell_Shadow_RitualOfSacrifice",
	["Improved Slam"] = "Ability_Warrior_DecisiveStrike",
	["Improved Slice and Dice"] = "Ability_Rogue_SliceDice",
	["Improved Spellstone"] = "INV_Misc_Gem_Sapphire_01",
	["Improved Sprint"] = "Ability_Rogue_Sprint",
	["Improved Starfire"] = "Spell_Arcane_StarFire",
	["Improved Stoneclaw Totem"] = "Spell_Nature_StoneClawTotem",
	["Improved Stoneskin Totem"] = "Spell_Nature_StoneSkinTotem",
	["Improved Strength of Earth Totem"] = "Spell_Nature_EarthBindTotem",
	["Improved Succubus"] = "Spell_Shadow_SummonSuccubus",
	["Improved Sunder Armor"] = "Ability_Warrior_Sunder",
	["Improved Taunt"] = "Spell_Nature_Reincarnation",
	["Improved Thorns"] = "Spell_Nature_Thorns",
	["Improved Thunder Clap"] = "Ability_ThunderClap",
	["Improved Tranquility"] = "Spell_Nature_Tranquility",
	["Improved Vampiric Embrace"] = "Spell_Shadow_ImprovedVampiricEmbrace",
	["Improved Vanish"] = "Ability_Vanish",
	["Improved Voidwalker"] = "Spell_Shadow_SummonVoidWalker",
	["Improved Windfury Weapon"] = "Spell_Nature_Cyclone",
	["Improved Wing Clip"] = "Ability_Rogue_Trip",
	["Improved Wrath"] = "Spell_Nature_AbolishMagic",
	["Incinerate"] = "Spell_Fire_FlameShock",
	["Inferno"] = "Spell_Shadow_SummonInfernal",
	["Initiative"] = "Spell_Shadow_Fumble",
	["Inner Fire"] = "Spell_Holy_InnerFire",
	["Inner Focus"] = "Spell_Frost_WindWalkOn",
	["Innervate"] = "Spell_Nature_Lightning",
	["Insect Swarm"] = "Spell_Nature_InsectSwarm",
	["Inspiration"] = "Spell_Holy_LayOnHands",
	["Instant Poison II"] = "Ability_Poisons",
	["Instant Poison III"] = "Ability_Poisons",
	["Instant Poison IV"] = "Ability_Poisons",
	["Instant Poison V"] = "Ability_Poisons",
	["Instant Poison VI"] = "Ability_Poisons",
	["Instant Poison"] = "Ability_Poisons",
	["Intensity"] = "Spell_Fire_LavaSpawn",
	["Intercept"] = "Ability_Rogue_Sprint",
	["Intercept Stun"] = "Ability_Rogue_Sprint",
	["Intimidating Shout"] = "Ability_GolemThunderClap",
	["Intimidation"] = "Ability_Devour",
	["Iron Will"] = "Spell_Magic_MageArmor",
	["Judgement of Command"] = "Ability_Warrior_InnerRage",
	["Judgement of Justice"] = "Spell_Holy_SealOfWrath",
	["Judgement of Light"] = "Spell_Holy_HealingAura",
	["Judgement of Righteousness"] = "Ability_ThunderBolt",
	["Judgement of Wisdom"] = "Spell_Holy_RighteousnessAura",
	["Judgement of the Crusader"] = "Spell_Holy_HolySmite",
	["Judgement"] = "Spell_Holy_RighteousFury",
	["Kick"] = "Ability_Kick",
	["Kidney Shot"] = "Ability_Rogue_KidneyShot",
	["Killer Instinct"] = "Spell_Holy_BlessingOfStamina",
	["Kodo Riding"] = "Spell_Nature_Swiftness",
	["Lash of Pain"] = "Spell_Shadow_Curse",
	["Last Stand"] = "Spell_Holy_AshesToAshes",
	["Lasting Judgement"] = "Spell_Holy_HealingAura",
	["Lay on Hands"] = "Spell_Holy_LayOnHands",
	["Leader of the Pack"] = "Spell_Nature_UnyeildingStamina",
	["Leather"] = "INV_Chest_Leather_09",
	["Leatherworking"] = "INV_Misc_ArmorKit_17",
	["Lesser Heal"] = "Spell_Holy_LesserHeal",
	["Lesser Healing Wave"] = "Spell_Nature_HealingWaveLesser",
	["Lesser Invisibility"] = "Spell_Magic_LesserInvisibilty",
	["Lethal Shots"] = "Ability_SearingArrow",
	["Lethality"] = "Ability_CriticalStrike",
	["Levitate"] = "Spell_Holy_LayOnHands",
	["Libram"] = "INV_Misc_Book_11",
	["Life Tap"] = "Spell_Shadow_BurningSpirit",
	["Lightning Bolt"] = "Spell_Nature_Lightning",
	["Lightning Breath"] = "Spell_Nature_Lightning",
	["Lightning Mastery"] = "Spell_Lightning_LightningBolt01",
	["Lightning Reflexes"] = "Spell_Nature_Invisibilty",
	["Lightning Shield"] = "Spell_Nature_LightningShield",
	["Lightwell Renew"] = "Spell_Holy_SummonLightwell",
	["Lightwell"] = "Spell_Holy_SummonLightwell",
	["Long Daze"] = "Spell_Frost_Stun",
	["Mace Specialization"] = "INV_Mace_01",
	["Mace Stun Effect"] = "Spell_Frost_Stun",
	["Mage Armor"] = "Spell_MageArmor",
	["Magma Totem"] = "Spell_Fire_SelfDestruct",
	["Mail"] = "INV_Chest_Chain_05",
	["Malice"] = "Ability_Racial_BloodRage",
	["Mana Burn"] = "Spell_Shadow_ManaBurn",
	["Mana Shield"] = "Spell_Shadow_DetectLesserInvisibility",
	["Mana Spring Totem"] = "Spell_Nature_ManaRegenTotem",
	["Mana Tide Totem"] = "Spell_Frost_SummonWaterElemental",
	["Mangle"] = "Ability_Druid_Mangle.tga",
	["Mark of the Wild"] = "Spell_Nature_Regeneration",
	["Martyrdom"] = "Spell_Nature_Tranquility",
	["Master Demonologist"] = "Spell_Shadow_ShadowPact",
	["Master Summoner"] = "Spell_Shadow_ImpPhaseShift",
	["Master of Deception"] = "Spell_Shadow_Charm",
	["Maul"] = "Ability_Druid_Maul",
	["Mechanostrider Piloting"] = "Spell_Nature_Swiftness",
	["Meditation"] = "Spell_Nature_Sleep",
	["Melee Specialization"] = "INV_Axe_02",
	["Mend Pet"] = "Ability_Hunter_MendPet",
	["Mental Agility"] = "Ability_Hibernation",
	["Mental Strength"] = "Spell_Nature_EnchantArmor",
	["Mind Blast"] = "Spell_Shadow_UnholyFrenzy",
	["Mind Control"] = "Spell_Shadow_ShadowWordDominate",
	["Mind Flay"] = "Spell_Shadow_SiphonMana",
	["Mind Soothe"] = "Spell_Holy_MindSooth",
	["Mind Vision"] = "Spell_Holy_MindVision",
	["Mind-numbing Poison II"] = "Spell_Nature_NullifyDisease",
	["Mind-numbing Poison III"] = "Spell_Nature_NullifyDisease",
	["Mind-numbing Poison"] = "Spell_Nature_NullifyDisease",
	["Mining"] = "Spell_Fire_FlameBlades",
	["Mocking Blow"] = "Ability_Warrior_PunishingBlow",
	["Mongoose Bite"] = "Ability_Hunter_SwiftStrike",
	["Monster Slaying"] = "INV_Misc_Head_Dragon_Black",
	["Moonfire"] = "Spell_Nature_StarFall",
	["Moonfury"] = "Spell_Nature_MoonGlow",
	["Moonglow"] = "Spell_Nature_Sentinal",
	["Moonkin Aura"] = "Spell_Nature_MoonGlow",
	["Moonkin Form"] = "Spell_Nature_ForceOfNature",
	["Mortal Shots"] = "Ability_PierceDamage",
	["Mortal Strike"] = "Ability_Warrior_SavageBlow",
	["Multi-Shot"] = "Ability_UpgradeMoonGlaive",
	["Murder"] = "Spell_Shadow_DeathScream",
	["Natural Armor"] = "Spell_Nature_SpiritArmor",
	["Natural Shapeshifter"] = "Spell_Nature_WispSplode",
	["Natural Weapons"] = "INV_Staff_01",
	["Nature Resistance Totem"] = "Spell_Nature_NatureResistanceTotem",
	["Nature Resistance"] = "Spell_Nature_ResistNature",
	["Nature's Focus"] = "Spell_Nature_HealingWaveGreater",
	["Nature's Grace"] = "Spell_Nature_NaturesBlessing",
	["Nature's Grasp"] = "Spell_Nature_NaturesWrath",
	["Nature's Reach"] = "Spell_Nature_NatureTouchGrow",
	["Nature's Swiftness"] = "Spell_Nature_RavenForm",
	["Nightfall"] = "Spell_Shadow_Twilight",
	["Omen of Clarity"] = "Spell_Nature_CrystalBall",
	["One-Handed Axes"] = "INV_Axe_01",
	["One-Handed Maces"] = "INV_Mace_01",
	["One-Handed Swords"] = "Ability_MeleeDamage",
	["One-Handed Weapon Specialization"] = "INV_Sword_20",
	["Opening - No Text"] = "Temp",
	["Opening"] = "Temp",
	["Opportunity"] = "Ability_Warrior_WarCry",
	["Overpower"] = "Ability_MeleeDamage",
	["Paranoia"] = "Spell_Shadow_AuraOfDarkness",
	["Parry"] = "Ability_Parry",
	["Pathfinding"] = "Ability_Mount_JungleTiger",
	["Perception"] = "Spell_Nature_Sleep",
	["Permafrost"] = "Spell_Frost_Wisp",
	["Pet Aggression"] = "Ability_Druid_Maul",
	["Pet Hardiness"] = "Ability_BullRush",
	["Pet Recovery"] = "Ability_Hibernation",
	["Pet Resistance"] = "Spell_Holy_BlessingOfAgility",
	["Phase Shift"] = "Spell_Shadow_ImpPhaseShift",
	["Pick Lock"] = "Spell_Nature_MoonKey",
	["Pick Pocket"] = "INV_Misc_Bag_11",
	["Piercing Howl"] = "Spell_Shadow_DeathScream",
	["Piercing Ice"] = "Spell_Frost_Frostbolt",
	["Plate Mail"] = "INV_Chest_Plate01",
	["Poison Cleansing Totem"] = "Spell_Nature_PoisonCleansingTotem",
	["Poisons"] = "Trade_BrewPoison",
	["Polearm Specialization"] = "INV_Weapon_Halbard_01",
	["Polearms"] = "INV_Spear_06",
	["Polymorph"] = "Spell_Nature_Polymorph",
	["Polymorph: Pig"] = "Spell_Magic_PolymorphPig",
	["Polymorph: Turtle"] = "Ability_Hunter_Pet_Turtle",
	["Portal: Darnassus"] = "Spell_Arcane_PortalDarnassus",
	["Portal: Ironforge"] = "Spell_Arcane_PortalIronForge",
	["Portal: Orgrimmar"] = "Spell_Arcane_PortalOrgrimmar",
	["Portal: Stormwind"] = "Spell_Arcane_PortalStormWind",
	["Portal: Thunder Bluff"] = "Spell_Arcane_PortalThunderBluff",
	["Portal: Undercity"] = "Spell_Arcane_PortalUnderCity",
	["Pounce Bleed"] = "Ability_Druid_SupriseAttack",
	["Pounce"] = "Ability_Druid_SupriseAttack",
	["Power Infusion"] = "Spell_Holy_PowerInfusion",
	["Power Word: Fortitude"] = "Spell_Holy_WordFortitude",
	["Power Word: Shield"] = "Spell_Holy_PowerWordShield",
	["Prayer of Fortitude"] = "Spell_Holy_PrayerOfFortitude",
	["Prayer of Healing"] = "Spell_Holy_PrayerOfHealing02",
	["Prayer of Shadow Protection"] = "Spell_Holy_PrayerofShadowProtection",
	["Prayer of Spirit"] = "Spell_Holy_PrayerofSpirit",
	["Precision"] = "Ability_Marksmanship",
	["Predatory Strikes"] = "Ability_Hunter_Pet_Cat",
	["Premeditation"] = "Spell_Shadow_Possession",
	["Preparation"] = "Spell_Shadow_AntiShadow",
	["Presence of Mind"] = "Spell_Nature_EnchantArmor",
	["Primal Fury"] = "Ability_Racial_Cannibalize",
	["Prowl"] = "Ability_Druid_SupriseAttack",
	["Psychic Scream"] = "Spell_Shadow_PsychicScream",
	["Pummel"] = "INV_Gauntlets_04",
	["Purge"] = "Spell_Nature_Purge",
	["Purification"] = "Spell_Frost_WizardMark",
	["Purify"] = "Spell_Holy_Purify",
	["Pursuit of Justice"] = "Spell_Holy_PersuitofJustice",
	["Pyroblast"] = "Spell_Fire_Fireball02",
	["Pyroclasm"] = "Spell_Fire_Volcano",
	["Quickness"] = "Ability_Racial_ShadowMeld",
	["Rain of Fire"] = "Spell_Shadow_RainOfFire",
	["Rake"] = "Ability_Druid_Disembowel",
	["Ram Riding"] = "Spell_Nature_Swiftness",
	["Ranged Weapon Specialization"] = "INV_Weapon_Rifle_06",
	["Rapid Concealment"] = "Ability_Ambush",
	["Rapid Fire"] = "Ability_Hunter_RunningShot",
	["Raptor Riding"] = "Spell_Nature_Swiftness",
	["Raptor Strike"] = "Ability_MeleeDamage",
	["Ravage"] = "Ability_Druid_Ravage",
	["Readiness"] = "Spell_Nature_Sleep",
	["Rebirth"] = "Spell_Nature_Reincarnation",
	["Recklessness"] = "Ability_CriticalStrike",
	["Reckoning"] = "Spell_Holy_BlessingOfStrength",
	["Redemption"] = "Spell_Holy_Resurrection",
	["Redoubt"] = "Ability_Defend",
	["Reflection"] = "Spell_Frost_WindWalkOn",
	["Reflection "] = "Spell_Frost_WindWalkOn",
	["Regeneration"] = "Spell_Nature_Regenerate",
	["Regrowth"] = "Spell_Nature_ResistNature",
	["Reincarnation"] = "Spell_Nature_Reincarnation",
	["Rejuvenation"] = "Spell_Nature_Rejuvenation",
	["Relentless Strikes"] = "Ability_Warrior_DecisiveStrike",
	["Remorseless Attacks"] = "Ability_FiegnDead",
	["Remove Curse"] = "Spell_Holy_RemoveCurse",
	["Remove Insignia"] = "Temp",
	["Remove Lesser Curse"] = "Spell_Nature_RemoveCurse",
	["Rend"] = "Ability_Gouge",
	["Renew"] = "Spell_Holy_Renew",
	["Repentance"] = "Spell_Holy_PrayerOfHealing",
	["Resurrection"] = "Spell_Holy_Resurrection",
	["Retaliation"] = "Ability_Warrior_Challange",
	["Retribution Aura"] = "Spell_Holy_AuraOfLight",
	["Revenge Stun"] = "Ability_Warrior_Revenge",
	["Revenge"] = "Ability_Warrior_Revenge",
	["Reverberation"] = "Spell_Frost_FrostWard",
	["Revive Pet"] = "Ability_Hunter_BeastSoothe",
	["Righteous Fury"] = "Spell_Holy_SealOfFury",
	["Rip"] = "Ability_GhoulFrenzy",
	["Riposte"] = "Ability_Warrior_Challange",
	["Ritual of Doom Effect"] = "Spell_Arcane_PortalDarnassus",
	["Ritual of Doom"] = "Spell_Shadow_AntiMagicShell",
	["Ritual of Summoning"] = "Spell_Shadow_Twilight",
	["Rockbiter Weapon"] = "Spell_Nature_RockBiter",
	["Rogue Passive"] = "Ability_Stealth",
	["Ruin"] = "Spell_Shadow_ShadowWordPain",
	["Rupture"] = "Ability_Rogue_Rupture",
	["Ruthlessness"] = "Ability_Druid_Disembowel",
	["Sacrifice"] = "Spell_Shadow_SacrificialShield",
	["Safe Fall"] = "INV_Feather_01",
	["Sanctity Aura"] = "Spell_Holy_MindVision",
	["Sap"] = "Ability_Sap",
	["Savage Fury"] = "Ability_Druid_Ravage",
	["Savage Strikes"] = "Ability_Racial_BloodRage",
	["Scare Beast"] = "Ability_Druid_Cower",
	["Scatter Shot"] = "Ability_GolemStormBolt",
	["Scorch"] = "Spell_Fire_SoulBurn",
	["Scorpid Poison"] = "Ability_PoisonSting",
	["Scorpid Sting"] = "Ability_Hunter_CriticalShot",
	["Screech"] = "Ability_Hunter_Pet_Bat",
	["Seal Fate"] = "Spell_Shadow_ChillTouch",
	["Seal of Command"] = "Ability_Warrior_InnerRage",
	["Seal of Justice"] = "Spell_Holy_SealOfWrath",
	["Seal of Light"] = "Spell_Holy_HealingAura",
	["Seal of Righteousness"] = "Ability_ThunderBolt",
	["Seal of Wisdom"] = "Spell_Holy_RighteousnessAura",
	["Seal of the Crusader"] = "Spell_Holy_HolySmite",
	["Searing Light"] = "Spell_Holy_SearingLightPriest",
	["Searing Pain"] = "Spell_Fire_SoulBurn",
	["Searing Totem"] = "Spell_Fire_SearingTotem",
	["Seduction"] = "Spell_Shadow_MindSteal",
	["Sense Demons"] = "Spell_Shadow_Metamorphosis",
	["Sense Undead"] = "Spell_Holy_SenseUndead",
	["Sentry Totem"] = "Spell_Nature_RemoveCurse",
	["Serpent Sting"] = "Ability_Hunter_Quickshot",
	["Setup"] = "Spell_Nature_MirrorImage",
	["Shackle Undead"] = "Spell_Nature_Slow",
	["Shadow Affinity"] = "Spell_Shadow_ShadowWard",
	["Shadow Bolt"] = "Spell_Shadow_ShadowBolt",
	["Shadow Focus"] = "Spell_Shadow_BurningSpirit",
	["Shadow Mastery"] = "Spell_Shadow_ShadeTrueSight",
	["Shadow Protection"] = "Spell_Shadow_AntiShadow",
	["Shadow Reach"] = "Spell_Shadow_ChillTouch",
	["Shadow Resistance Aura"] = "Spell_Shadow_SealOfKings",
	["Shadow Resistance"] = "Spell_Shadow_AntiShadow",
	["Shadow Trance"] = "Spell_Shadow_Twilight",
	["Shadow Ward"] = "Spell_Shadow_AntiShadow",
	["Shadow Weaving"] = "Spell_Shadow_BlackPlague",
	["Shadow Word: Pain"] = "Spell_Shadow_ShadowWordPain",
	["Shadowburn"] = "Spell_Shadow_ScourgeBuild",
	["Shadowform"] = "Spell_Shadow_Shadowform",
	["Shadowguard"] = "Spell_Nature_LightningShield",
	["Shadowmeld Passive"] = "Ability_Ambush",
	["Shadowmeld"] = "Ability_Ambush",
	["Sharpened Claws"] = "INV_Misc_MonsterClaw_04",
	["Shatter"] = "Spell_Frost_FrostShock",
	["Shell Shield"] = "Ability_Hunter_Pet_Turtle",
	["Shield Bash"] = "Ability_Warrior_ShieldBash",
	["Shield Block"] = "Ability_Defend",
	["Shield Slam"] = "INV_Shield_05",
	["Shield Specialization"] = "INV_Shield_06",
	["Shield Wall"] = "Ability_Warrior_ShieldWall",
	["Shield"] = "INV_Shield_04",
	["Shoot Bow"] = "Ability_Marksmanship",
	["Shoot Crossbow"] = "Ability_Marksmanship",
	["Shoot Gun"] = "Ability_Marksmanship",
	["Shoot"] = "Ability_ShootWand",
	["Shred"] = "Spell_Shadow_VampiricAura",
	["Silence"] = "Spell_Shadow_ImpPhaseShift",
	["Silent Resolve"] = "Spell_Nature_ManaRegenTotem",
	["Sinister Strike"] = "Spell_Shadow_RitualOfSacrifice",
	["Siphon Life"] = "Spell_Shadow_Requiem",
	["Skinning"] = "INV_Misc_Pelt_Wolf_01",
	["Slam"] = "Ability_Warrior_DecisiveStrike",
	["Slice and Dice"] = "Ability_Rogue_SliceDice",
	["Slow Fall"] = "Spell_Magic_FeatherFall",
	["Smelting"] = "Spell_Fire_FlameBlades",
	["Smite"] = "Spell_Holy_HolySmite",
	["Soothe Animal"] = "Ability_Hunter_BeastSoothe",
	["Soothing Kiss"] = "Spell_Shadow_SoothingKiss",
	["Soul Fire"] = "Spell_Fire_Fireball02",
	["Soul Link"] = "Spell_Shadow_GatherShadows",
	["Soulstone Resurrection"] = "INV_Misc_Orb_04",
	["Spell Lock"] = "Spell_Shadow_MindRot",
	["Spell Warding"] = "Spell_Holy_SpellWarding",
	["Spirit Bond"] = "Ability_Druid_DemoralizingRoar",
	["Spirit Tap"] = "Spell_Shadow_Requiem",
	["Spirit of Redemption"] = "INV_Enchant_EssenceEternalLarge",
	["Spiritual Focus"] = "Spell_Arcane_Blink",
	["Spiritual Guidance"] = "Spell_Holy_SpiritualGuidence",
	["Spiritual Healing"] = "Spell_Nature_MoonGlow",
	["Sprint"] = "Ability_Rogue_Sprint",
	["Starfire"] = "Spell_Arcane_StarFire",
	["Starshards"] = "Spell_Arcane_StarFire",
	["Staves"] = "INV_Staff_08",
	["Stealth"] = "Ability_Stealth",
	["Stoneclaw Totem"] = "Spell_Nature_StoneClawTotem",
	["Stoneform"] = "Spell_Shadow_UnholyStrength",
	["Stoneskin Totem"] = "Spell_Nature_StoneSkinTotem",
	["Stormstrike"] = "Spell_Holy_SealOfMight",
	["Strength of Earth Totem"] = "Spell_Nature_EarthBindTotem",
	["Stuck"] = "Spell_Shadow_Teleport",
	["Subtlety"] = "Ability_EyeOfTheOwl",
	["Suffering"] = "Spell_Shadow_BlackPlague",
	["Summon Charger"] = "Ability_Mount_Charger",
	["Summon Dreadsteed"] = "Ability_Mount_Dreadsteed",
	["Summon Felhunter"] = "Spell_Shadow_SummonFelHunter",
	["Summon Felsteed"] = "Spell_Nature_Swiftness",
	["Summon Imp"] = "Spell_Shadow_SummonImp",
	["Summon Succubus"] = "Spell_Shadow_SummonSuccubus",
	["Summon Voidwalker"] = "Spell_Shadow_SummonVoidWalker",
	["Summon Warhorse"] = "Spell_Nature_Swiftness",
	["Sunder Armor"] = "Ability_Warrior_Sunder",
	["Suppression"] = "Spell_Shadow_UnsummonBuilding",
	["Surefooted"] = "Ability_Kick",
	["Survivalist"] = "Spell_Shadow_Twilight",
	["Sweeping Strikes"] = "Ability_Rogue_SliceDice",
	["Swipe"] = "INV_Misc_MonsterClaw_03",
	["Sword Specialization"] = "INV_Sword_27",
	["Tactical Mastery"] = "Spell_Nature_EnchantArmor",
	["Tailoring"] = "Trade_Tailoring",
	["Tainted Blood"] = "Spell_Shadow_LifeDrain",
	["Tame Beast"] = "Ability_Hunter_BeastTaming",
	["Tamed Pet Passive"] = "Ability_Mount_PinkTiger",
	["Taunt"] = "Spell_Nature_Reincarnation",
	["Teleport: Darnassus"] = "Spell_Arcane_TeleportDarnassus",
	["Teleport: Ironforge"] = "Spell_Arcane_TeleportIronForge",
	["Teleport: Moonglade"] = "Spell_Arcane_TeleportMoonglade",
	["Teleport: Orgrimmar"] = "Spell_Arcane_TeleportOrgrimmar",
	["Teleport: Stormwind"] = "Spell_Arcane_TeleportStormWind",
	["Teleport: Thunder Bluff"] = "Spell_Arcane_TeleportThunderBluff",
	["Teleport: Undercity"] = "Spell_Arcane_TeleportUnderCity",
	["The Human Spirit"] = "INV_Enchant_ShardBrilliantSmall",
	["Thick Hide"] = "INV_Misc_Pelt_Bear_03",
	["Thorns"] = "Spell_Nature_Thorns",
	["Throw"] = "Ability_Throw",
	["Throwing Specialization"] = "INV_ThrowingAxe_03",
	["Throwing Weapon Specialization"] = "INV_ThrowingKnife_01",
	["Thrown"] = "INV_ThrowingKnife_02",
	["Thunder Clap"] = "Spell_Nature_ThunderClap",
	["Thundering Strikes"] = "Ability_ThunderBolt",
	["Thunderstomp"] = "Ability_Hunter_Pet_Gorilla",
	["Tidal Focus"] = "Spell_Frost_ManaRecharge",
	["Tidal Mastery"] = "Spell_Nature_Tranquility",
	["Tiger Riding"] = "Spell_Nature_Swiftness",
	["Tiger's Fury"] = "Ability_Mount_JungleTiger",
	["Torment"] = "Spell_Shadow_GatherShadows",
	["Totem"] = "Spell_Nature_StoneClawTotem",
	["Totemic Focus"] = "Spell_Nature_MoonGlow",
	["Touch of Weakness"] = "Spell_Shadow_DeadofNight",
	["Toughness"] = "Spell_Holy_Devotion",
	["Track Beasts"] = "Ability_Tracking",
	["Track Demons"] = "Spell_Shadow_SummonFelHunter",
	["Track Dragonkin"] = "INV_Misc_Head_Dragon_01",
	["Track Elementals"] = "Spell_Frost_SummonWaterElemental",
	["Track Giants"] = "Ability_Racial_Avatar",
	["Track Hidden"] = "Ability_Stealth",
	["Track Humanoids"] = "Ability_Tracking",
	["Track Undead"] = "Spell_Shadow_DarkSummoning",
	["Tranquil Air Totem"] = "Spell_Nature_Brilliance",
	["Tranquil Spirit"] = "Spell_Holy_ElunesGrace",
	["Tranquility"] = "Spell_Nature_Tranquility",
	["Tranquilizing Shot"] = "Spell_Nature_Drowsy",
	["Trap Mastery"] = "Ability_Ensnare",
	["Travel Form"] = "Ability_Druid_TravelForm",
	["Tremor Totem"] = "Spell_Nature_TremorTotem",
	["Trueshot Aura"] = "Ability_TrueShot",
	["Turn Undead"] = "Spell_Holy_TurnUndead",
	["Two-Handed Axes and Maces"] = "INV_Axe_10",
	["Two-Handed Axes"] = "INV_Axe_04",
	["Two-Handed Maces"] = "INV_Mace_04",
	["Two-Handed Swords"] = "Ability_MeleeDamage",
	["Two-Handed Weapon Specialization"] = "INV_Axe_09",
	["Unarmed"] = "Ability_GolemThunderClap",
	["Unbreakable Will"] = "Spell_Magic_MageArmor",
	["Unbridled Wrath Effect"] = "Spell_Nature_StoneClawTotem",
	["Unbridled Wrath"] = "Spell_Nature_StoneClawTotem",
	["Undead Horsemanship"] = "Spell_Nature_Swiftness",
	["Underwater Breathing"] = "Spell_Shadow_DemonBreath",
	["Unending Breath"] = "Spell_Shadow_DemonBreath",
	["Unholy Power"] = "Spell_Shadow_ShadowWordDominate",
	["Unleashed Fury"] = "Ability_BullRush",
	["Unyielding Faith"] = "Spell_Holy_UnyieldingFaith",
	["Vampiric Embrace"] = "Spell_Shadow_UnsummonBuilding",
	["Vanish"] = "Ability_Vanish",
	["Vanished"] = "Ability_Vanish",
	["Vengeance"] = "Spell_Nature_Purge",
	["Vigor"] = "Spell_Nature_EarthBindTotem",
	["Vile Poisons"] = "Ability_Rogue_FeignDeath",
	["Vindication"] = "Spell_Holy_Vindication",
	["Viper Sting"] = "Ability_Hunter_AimedShot",
	["Volley"] = "Ability_Marksmanship",
	["Wand Specialization"] = "INV_Wand_01",
	["Wands"] = "Ability_ShootWand",
	["War Stomp"] = "Ability_WarStomp",
	["Water Breathing"] = "Spell_Shadow_DemonBreath",
	["Water Walking"] = "Spell_Frost_WindWalkOn",
	["Weakened Soul"] = "Spell_Holy_AshesToAshes",
	["Whirlwind"] = "Ability_Whirlwind",
	["Will of the Forsaken"] = "Spell_Shadow_RaiseDead",
	["Windfury Totem"] = "Spell_Nature_Windfury",
	["Windfury Weapon"] = "Spell_Nature_Cyclone",
	["Windwall Totem"] = "Spell_Nature_EarthBind",
	["Wing Clip"] = "Ability_Rogue_Trip",
	["Winter's Chill"] = "Spell_Frost_ChillingBlast",
	["Wisp Spirit"] = "Spell_Nature_WispSplode",
	["Wolf Riding"] = "Spell_Nature_Swiftness",
	["Wound Poison II"] = "INV_Misc_Herb_16",
	["Wound Poison III"] = "INV_Misc_Herb_16",
	["Wound Poison IV"] = "INV_Misc_Herb_16",
	["Wound Poison"] = "INV_Misc_Herb_16",
	["Wrath"] = "Spell_Nature_AbolishMagic",
	["Wyvern Sting"] = "INV_Spear_02"
}

BabbleSpell = {}
function BabbleSpell:GetSpellIcon(spell)
	if spellIcons[spell] then
		return "Interface\\Icons\\" .. spellIcons[spell]
	end
	return nil
end

function BabbleSpell:GetTranslation(spell)
	return spell
end
